// PDSMath.h

#if !defined(PDSMath_h)
#define PDSMath_h

#include <math.h>
#include <afxwin.h>
#include <afxtempl.h>

#define CONST_PI 3.14159265359
#define DBL_MIN 2.2250738585072014e-308
#define DBL_MAX 1.7976931348623158e+308

#define RPG_PT_GNCP   0    //˵(ǻߵ)
#define RPG_PT_NGCP   1    //뻡ߵ
#define RPG_PT_NGNCP  2    //ֱߵ(ǻߵ)
#define RPG_PT_GCP    3    //뻡ߵ
#define RPG_PT_GP     64   //ֵ
#define RPG_PT_INSPT  100  //ֵ
#define RPG_PT_SEAM   128  //ݷ
#define RPG_PT_NODEF  -1  //޶

#define CONST_MAXDISTANCE       0.05  //ڲϵĵ,ĬжӦ,λ:mm. ǵϵͳеķֱΪ40,Сȡֵ0.05mm
#define F_MAX_TANGENT_ERROR     0.1   //20131015 ʱļ,λ:mm

#define CONST_SAME_POINT_ERROR  5  // жȵֵ,ϵͳڲλ,<=ֵĵΪͬһ
                                   // [20170830 syf]ʹݽṹֹ֧ʽ,µϵĵ12ڲλ,Ӹú궨жͬ
                                   // ڵķǳ,ڱ,ᵼ¼Ľƽ߳,
                                   // ڱϻȡĳ㴦ǰʱ,һҪǳĵ

//͵ĵ,Եûָ,ʹ߿ɸԼҪʹ
class CTypePoint : public CObject
{
public:
  CPoint m_ptPoint;
  int m_iType;
  
  CTypePoint();
  CTypePoint(CTypePoint &a);
  CTypePoint(CPoint ptPoint,int iType);
  ~CTypePoint();
  void operator=(const CTypePoint &a);
  BOOL operator==(CTypePoint& a);
  BOOL operator!=(CTypePoint& a);
};

class CTypePointListArray;  // 

//͵ĵ
class CTypePointList : public CList<CTypePoint,CTypePoint>
{
public:  //չı
public:  //չķ

  CTypePointList& operator=(CTypePointList& rhs);  //ֵ
  BOOL operator==(CTypePointList& rhs);  //Ⱥ
  BOOL operator!=(CTypePointList& rhs);  //Ⱥ
  CTypePoint& operator[](int iIndex);  //ֵ,Խ

  //²ҶǴHead->GetNext->Tail,һ߼

  //Ҹеֵ
  int FindIndexOfTypePoint(CTypePoint TypePoint);

  //Ҹλ
  POSITION FindPositionOfPoint(CPoint ptPoint);

  //Ҹеֵ
  int FindIndexOfPoint(CPoint ptPoint);

  //Ҹеλ
  POSITION FindPositionOfType(int iType);

  //Ҹеֵ
  int FindIndexOfType(int iType);

  //ݸthis
  //ر˵:
  //  ɺ,thisĳȵlistPoint,ÿһһӦ,thisÿһ͵iType
  void SetTypePointList(int iType, CList<CPoint,CPoint>& listPoint);

  //thisеĵȡlistPoint
  void ExtractPointList(CList<CPoint,CPoint>& listPoint);

  //listPointõthism_ptPoint
  void SetOnlyPointList(CList<CPoint,CPoint>& listPoint);

  //ָͽthisֶ
  //ر˵:
  //  (1)Ӧþ,úӦڸݷ㽫Ƶֶ,iTypeʵϱʾbGrade
  //  (2)alTypePoint[],ᱣ֤һ
  //  (3)bClose=true,ôҪ֤iType,alTypePointֻһ,ҵthis
  //:
  //  bClose  =true պ,ͷβ㲻,ж,=false 
  //  iType   
  //:
  //  alTypePoint  ,iTypeĵҪΪöν
  void DivideTypePointListEqualType(BOOL bClose, int iType, CTypePointListArray& alTypePoint);

  //ֻҪͲ0ͽзֶ
  //ر˵:
  //  (1)Ӧþ,úӦڸݷݽʵʵķֶ,m_iTypeʵϱʾݵָ
  //  (2)ֶι,ÿһεͷβз,мĵûз,Ӷμ
  //  (3)alTypePoint[],ᱣ֤һ
  //  (4)bClose=true,ôҪ֤m_iTypeΪ0,alTypePointֻһ,ҵthis
  //:
  //  bClose  =true պ,ͷβ㲻,ж,=false 
  //:
  //  alTypePoint  ,bClose=true,ôÿεͷβm_iTypeΪ0
  void DivideTypePointListWhenTypeNoZero(BOOL bClose, CTypePointListArray& alTypePoint);

  //m_iTypeֵ
  //ر˵:
  //  (1)Ӧþ,m_ptPointʾ,m_iTypeʾýͷľ(ϳ),ô,Sort֮Ľ
  //:
  //  bSmallToLarge  =true С,=false ӴС
  void SortByType(BOOL bSmallToLarge = TRUE);

  void MakeReverse();  //this

  POSITION FindPositionOfSmallestType(void);  //m_iTypeСǸԪصλ
  int FindIndexOfSmallestType(void);  // m_iTypeСǸԪصֵ

  POSITION FindPositionOfLargestType(void);  //m_iTypeǸԪصλ
  int FindIndexOfLargestType(void);  // m_iTypeǸԪصֵ

  //߲
  //:
  //  ptPoint      
  //  dMaxError    жϵϵֵ
  //  iInsertType  ʱm_iTypeֵ
  //ֵ:
  //  =true this(ʱѾthis,this),=false 㲻this
  BOOL InsertPointAtPolyline(CPoint ptPoint, double dMaxError, int iInsertType = 0);

  //ڶβ
  //:
  //  ptPoint      
  //  dMaxError    жϵϵֵ
  //  iInsertType  ʱm_iTypeֵ
  //ֵ:
  //  =true this(ʱѾthis,this),=false 㲻this
  BOOL InsertPointAtPolygon(CPoint ptPoint, double dMaxError, int iInsertType = 0);

  //
  CPoint FindNearestPoint(CPoint ptPoint);
  //㲢
  CPoint FindNearestPoint(CPoint ptPoint, int& nDistance);
  //ֵ
  BOOL FindNearestPoint(CPoint ptPoint, double dMaxError, CPoint& ptOutput);
};

//͵
class CTypePointListArray : public CArray<CTypePointList,CTypePointList&>
{
public:  //չı
public:  //չķ

  CTypePointListArray& operator=(CTypePointListArray& rhs);  //ֵ
};

class CRPGrade_Point : public CObject  {
public:
  CPoint m_ptPoint;
  int m_nType;
  long n_SerNo;

public:

  CRPGrade_Point();
  CRPGrade_Point(CRPGrade_Point &a);
  CRPGrade_Point(CPoint ptPoint,int nType,long nSerNo);
  CRPGrade_Point(CPoint ptPoint,int nType);
  ~CRPGrade_Point();
  void operator=(CRPGrade_Point &a);
};

class CRotateMove : public CObject {
public:
  double m_dAngle;  //תĽǶ
  double m_dSin,m_dCos;  //תĽǶ,,˱Ϊ˲ظ
  CPoint m_ptPointO;  //תԭ
  CPoint m_ptOffset;  //ƫ

public:
  CRotateMove();
  CRotateMove(CRotateMove& rhs);
  CRotateMove(double dAngle,CPoint ptPointO,CPoint ptOffset);
  ~CRotateMove();
  void operator=(CRotateMove &a);

  void Initial();
};

class CRotateMoveList : public CList<CRotateMove,CRotateMove>
{
public:  //չı
public:  //չķ

  CRotateMoveList& operator=(CRotateMoveList& rhs);  //ֵ
  CRotateMove& operator[](int iIndex);  //ֵ,Խ
};

class CDBLPoint : public CObject {
public:
  double x,y;

public:
  CDBLPoint();
  CDBLPoint(double x1,double y1);
  CDBLPoint(CDBLPoint &a);
  ~CDBLPoint();
  void operator=(CDBLPoint &a);
  BOOL operator==(CDBLPoint &a);

  //ʹptPointthis
  void SetPoint(CPoint ptPoint);

  //CPoint
  CPoint GetPoint(void);
};

class CDBLPointList : public CList<CDBLPoint,CDBLPoint>
{
public:  //չı
public:  //չķ

  CDBLPointList& operator=(CDBLPointList& rhs);  //ֵ
  CDBLPoint& operator[](int iIndex);  //ֵ,Խ

  //ʹlistPointthis
  void SetPoint(CList<CPoint,CPoint>& listPoint);

  //thisеĵlistPoint
  void GetPoint(CList<CPoint,CPoint>& listPoint);
};

class CDBLPointListArray : public CArray<CDBLPointList,CDBLPointList&>
{
public:  //չı
public:  //չķ

  CDBLPointListArray& operator=(CDBLPointListArray& rhs);  //ֵ
};

class C4PRgn : public CObject  {
public:
  CPoint m_ptLU,m_ptLD,m_ptRU,m_ptRD;  //ַʾʱռõm_ptLUm_ptRUm_ptRDm_ptLDm_ptLU

public:
  C4PRgn();
  C4PRgn(C4PRgn &a);
  C4PRgn(CPoint ptLU,CPoint ptLD,CPoint ptRU,CPoint ptRD);
  void operator=(C4PRgn &a);
  BOOL operator==(C4PRgn& a);
};

//߶
class CLineSegment : public CObject
{
public:
  CPoint m_ptPointS;  // 
  CPoint m_ptPointE;  // յ

public:
  CLineSegment();
  CLineSegment(CPoint ptPointS, CPoint ptPointE);
  CLineSegment(CLineSegment& rhs);
  virtual ~CLineSegment();
  CLineSegment& operator=(CLineSegment& rhs);
  BOOL operator==(CLineSegment& rhs);

  void Initial();
};

//߶ε
class CLineSegmentList : public CList<CLineSegment,CLineSegment>
{
public:  //չı
public:  //չķ

  CLineSegmentList& operator=(CLineSegmentList& rhs);  //ֵ
  CLineSegment& operator[](int iIndex);  //ֵ,Խ
};

//߶
class CLineSegmentListArray : public CArray<CLineSegmentList,CLineSegmentList&>
{
public:  //չı
public:  //չķ

  CLineSegmentListArray& operator=(CLineSegmentListArray& rhs);  //ֵ
};

//ȡ
//:
//  x
//ֵ:
//  
int IntRound(double x);

//ת
//:
//    (nPx,nPy)ת,(x,y)תԭ,dSinBeta,dCosBetaʱתǶȵ
//:
//    (nPxNew,nPyNew)תֵ
void PointRotate(int nPx,int nPy,int x,int y,double dSinBeta,double dCosBeta,int& nPxNew,int& nPyNew);
void PointRotate(double dX,double dY,double dXO,double dYO,double dSinBeta,double dCosBeta,double& dXNew,double& dYNew);
//ת
//:
//    ptPointת,ptPointOתԭ,dSinBeta,dCosBetaʱתǶȵ
//:
//    ptPointתֵ
void PointRotate(CPoint &ptPoint,CPoint ptPointO,double dSinBeta,double dCosBeta);

//ת
//:
//    listPoint1תĵ,ptPointOתԭ,dSinBeta,dCosBetaʱתǶȵ
//:
//    listPoint2תֵ
void PointRotate(CList<CPoint,CPoint> &listPoint1,CPoint ptPointO,double dSinBeta,double dCosBeta,CList<CPoint,CPoint> &listPoint2);

//ƽ
//:
//    listPoint1ƽƵĵ
//    nDx,nDy  XYƽ
//:
//    listPoint2ƽƺֵ
void PointMove(CList<CPoint,CPoint> &listPoint1,int nDx,int nDy,CList<CPoint,CPoint> &listPoint2);

//ptPoint
//:
//  ptPoint 
//  dScale >1Ŵ,<1С
//ֵ:
//  ŴСĵ
CPoint PointScale(CPoint ptPoint,double dScale);
//ptPointOΪԭ㣬ptPointdScale
CPoint PointScale(CPoint ptPoint,CPoint ptPointO,double dScale);
//ptPointOΪԭ㣬ptPointOptPoint1Ϊ򣬽ptPointdScale
CPoint PointScale(CPoint ptPoint,CPoint ptPointO,CPoint ptPoint1,double dScale);

//Ըƽƺ
//:
//  ptPoint 
//  ptOffset  ƽ
//  dScale 
//ֵ:
//  ƽźĵ
CPoint PointMoveScale(CPoint ptPoint,CPoint ptOffset,double dScale);

//20140603 Ըƽת
//
//  ptPoint 
//  ptOrignalS  תԲS
//  ptOrignalE  תԲE
//  ptRotateS  תS
//  ptRotateE  תE
//ֵ
//  ƽת
CPoint PointMoveRotate(CPoint ptPoint, CPoint ptOrignalS, CPoint ptOrignalE, CPoint ptRotateS, CPoint ptRotateE);

//20140603 Ըƽת
//
//  listPoint 
//  ptOrignalS  תԲS
//  ptOrignalE  תԲE
//  ptRotateS  תS
//  ptRotateE  תE
//
//  listMoveRotatePointƽת
void PointMoveRotate(CList<CPoint, CPoint> &listPoint, CPoint ptOrignalS, CPoint ptOrignalE, CPoint ptRotateS, CPoint ptRotateE, CList<CPoint, CPoint> &listMoveRotatePoint);

//һԪηax2+bx+c=0
//ֵ:
//  =0,޽
//  =1,һx1(x2=x1)
//  =2,x1,x2
//  =3,ʵ
int Quadratic(double a,double b,double c,double& x1,double& x2);

//ֱ߷ax+by+c=0ϵ
//:
//  (x1,y1),(x2_y2) ֱ
//:
//  a,b,c ֱ߷ax+by+c=0ϵ
void LineEquationCoefficient(int x1,int y1,int x2,int y2,double& a,double& b,double& c);
void LineEquationCoefficient(double x1,double y1,double x2,double y2,double& a,double& b,double& c);

//ֱ߷ax+by+c=0ϵ
//:
//  ptPoint1,ptPoint2 ֱ
//:
//  a,b,c ֱ߷ax+by+c=0ϵ
void LineEquationCoefficient(CPoint ptPoint1,CPoint ptPoint2,double& a,double& b,double& c);

//ֱߵĽ
//
//  a1,b1,c1 ֱa1*x+b1*y+c1=0
//  a2,b2,c2 ֱa2*x+b2*y+c2=0
//
//  (x,y) 
//ֵ
//  =0,ûн
//  =1,н(x,y)
//  =2,ֱغ
int IntOfTwoLine(double a1,double b1,double c1,double a2,double b2,double c2,double& x,double& y);

//ֱߵĽ
//
//  a1,b1,c1 ֱa1*x+b1*y+c1=0
//  a2,b2,c2 ֱa2*x+b2*y+c2=0
//
//  (nx,ny) 
//ֵ
//  =0,ûн
//  =1,н(nx,ny)
//  =2,ֱغ
int IntOfTwoLine(double a1,double b1,double c1,double a2,double b2,double c2,int& nx,int& ny);

//ֱߵĽ
//
//  (nXS1,nYS1),(nXE1,nYE1) ֱ1յ
//  (nXS2,nYS2),(nXE2,nYE2) ֱ2յ
//
//  (nx,ny) 
//ֵ
//  =0,ûн
//  =1,н(nx,ny)
//  =2,ֱغ
int IntOfTwoLine(int nXS1,int nYS1,int nXE1,int nYE1,int nXS2,int nYS2,int nXE2,int nYE2,int& nx,int& ny);

//ֱߵĽ
//
//  PointS1_PointE1 ֱ1յ
//  PointS2_PointE2 ֱ2յ
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,нptIntersection
//  =2,ֱغ
int IntOfTwoLine(POINT PointS1,POINT PointE1,POINT PointS2,POINT PointE2,POINT& ptIntersection);

//ֱ߶εĽ
//
//  (nXS1,nYS1),(nXE1,nYE1) ֱ߶1յ
//  (nXS2,nYS2),(nXE2,nYE2) ֱ߶2յ
//
//  (nx,ny) 
//ֵ
//  =0,ûн
//  =1,ͬʱ߶(˵),(nx,ny)
//  =2,㲻߶(˵),(nx,ny)
//  =3,ûйͬ˵ص߶,߶ͬһֱ(һϵĽ)ûйͬĶ˵
//  =4,йͬ˵Ĳص߶,߶ͬһֱֻһ˵ص(nx,ny)
//  =5,йͬ˵ص߶,(nx,ny)صзǹͬĶ˵
int IntOfTwoLineSegment(int nXS1,int nYS1,int nXE1,int nYE1,int nXS2,int nYS2,int nXE2,int nYE2,int& nx,int& ny);

//ֱ߶εĽ
//
//  PointS1_PointE1 ֱ߶1յ
//  PointS2_PointE2 ֱ߶2յ
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,ͬʱ߶(˵),ptIntersection
//  =2,㲻߶(˵),ptIntersection
//  =3,ûйͬ˵ص߶,߶ͬһֱ(һϵĽ)ûйͬĶ˵
//  =4,йͬ˵Ĳص߶,߶ͬһֱֻһ˵صptIntersection
//  =5,йͬ˵ص߶,ptIntersectionصзǹͬĶ˵
int IntOfTwoLineSegment(POINT PointS1,POINT PointE1,POINT PointS2,POINT PointE2,POINT& ptIntersection);

//ֱߺֱ߶εĽ!!!
//ر˵:
//  úһֱߺһ߶εĽ,߶λֱߵĽ!!!
//  μIntOfTwoLineSegment(...),IntOfTwoLine(...).
//
//  a1,b1,c1 ֱa1*x+b1*y+c1=0
//  (nXS2,nYS2),(nXE2,nYE2) ߶εյ
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,߶(˵),(nx,ny)
//  =2,㲻߶(˵),(nx,ny)
//  =3,ֱߺ߶ͬһֱ
int IntOfLineLineSegment(double a1,double b1,double c1,int nXS2,int nYS2,int nXE2,int nYE2,int& nx,int& ny);

//ֱߺֱ߶εĽ!!!
//ر˵:
//  úһֱߺһ߶εĽ,߶λֱߵĽ!!!
//  μIntOfTwoLineSegment(...),IntOfTwoLine(...).
//
//  a1,b1,c1 ֱa1*x+b1*y+c1=0
//  PointS2,PointE2 ߶εյ
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,߶(˵),ptIntersection
//  =2,㲻߶(˵),ptIntersection
//  =3,ֱߺ߶ͬһֱ
int IntOfLineLineSegment(double a1,double b1,double c1,POINT PointS2,POINT PointE2,POINT& ptIntersection);

//ֱߺֱ߶εĽ!!!
//ر˵:
//  úһֱߺһ߶εĽ,߶λֱߵĽ!!!
//  μIntOfTwoLineSegment(...),IntOfTwoLine(...).
//
//  (nXS1,nYS1),(nXE1,nYE1) ֱߵյ
//  (nXS2,nYS2),(nXE2,nYE2) ߶εյ
//
//  (nx,ny) 
//ֵ
//  =0,ûн
//  =1,߶(˵),(nx,ny)
//  =2,㲻߶(˵),(nx,ny)
//  =3,ֱߺ߶ͬһֱ
int IntOfLineLineSegment(int nXS1,int nYS1,int nXE1,int nYE1,int nXS2,int nYS2,int nXE2,int nYE2,int& nx,int& ny);

//ֱߺֱ߶εĽ!!!
//ر˵:
//  úһֱߺһ߶εĽ,߶λֱߵĽ!!!
//  μIntOfTwoLineSegment(...),IntOfTwoLine(...).
//
//  PointS1_PointE1 ֱߵյ
//  PointS2_PointE2 ߶εյ
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,߶(˵),ptIntersection
//  =2,㲻߶(˵),ptIntersection
//  =3,ֱߺ߶ͬһֱ
int IntOfLineLineSegment(POINT PointS1,POINT PointE1,POINT PointS2,POINT PointE2,POINT& ptIntersection);
//ʸptPointS1ptPointE1ʸptPointS2ptPointE2Ľ!!!
//
//  PointS1,PointE1 ʸptPointS1ptPointE1
//  PointS2,PointE2 ʸptPointS2ptPointE2
//
//  ptIntersection 
//ֵ
//  =0,ûн
//  =1,нptIntersection
//  =2,ֱغ
int IntOfTwoVectorLine(POINT PointS1,POINT PointE1,POINT PointS2,POINT PointE2,POINT& ptIntersection);

//ֱߺԲĽ
//:
//  a,b,c ֱ:ax+by+c=0;
//  (xc,yc) Բ
//  nR 뾶
//:
//  lpptIntersection1,lpptIntersection2 ֱߺԲ
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfLineCircle(double a,double b,double c,int xc,int yc,int nR,LPPOINT lpptIntersection1,LPPOINT lpptIntersection2);

//ֱߺԲĽ
//:
//  ptPointS,ptPointE ֱߵֹ
//  ptCenter Բ
//  nRadius 뾶
//:
//  lpptIntersection1,lpptIntersection2 ֱߺԲ
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfLineCircle(POINT ptPointS,POINT ptPointE,POINT ptCenter,int nRadius,LPPOINT lpptIntersection1,LPPOINT lpptIntersection2);

//ֱߺԲĽ
//:
//  ptPointS,ptPointE ֱߵֹ
//  ptCenter Բ
//  nRadius 뾶
//:
//  ptIntersection1,ptIntersection2 ֱߺԲ
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfLineCircle(POINT ptPointS,POINT ptPointE,POINT ptCenter,int nRadius,CPoint& ptIntersection1,CPoint& ptIntersection2);

//ֱ߶κԲĽ
//:
//  ptPointS,ptPointE ֱ߶εֹ
//  ptCenter Բ
//  nRadius 뾶
//:
//  lpptIntersection1,lpptIntersection2 ֱߺԲ
//ֵ
//  =0,ûн
//  =1,һ(˵)
//  =2,(˵)
int IntOfLineSegmentCircle(POINT ptPointS,POINT ptPointE,POINT ptCenter,int nRadius,LPPOINT lpptIntersection1,LPPOINT lpptIntersection2);

//ֱ߶κԲĽ
//:
//  ptPointS,ptPointE ֱ߶εֹ
//  ptCenter Բ
//  nRadius 뾶
//:
//  ptIntersection1,ptIntersection2 ֱ߶κԲ
//ֵ
//  =0,ûн
//  =1,һ(˵)
//  =2,(˵)
int IntOfLineSegmentCircle(POINT ptPointS,POINT ptPointE,POINT ptCenter,int nRadius,CPoint& ptIntersection1,CPoint& ptIntersection2);

//ߺԲĽ
//:
//  listPolyline 
//  ptCenter Բ
//  nRadius 뾶
//:
//  listIntPoint ߺԲĽ
//ֵ
//  (=0,ûн)
int IntOfPolylineCircle(CList<CPoint,CPoint> &listPolyline,POINT ptCenter,int nRadius,CList<CPoint,CPoint> &listIntPoint);

//ԲĽ
//
//  x1,y1,r1 Բ:(x-x1)*(x-x1) + (y-y1)*(y-y1) = r1*r1
//  x2,y2,r2 Բ:(x-x2)*(x-x2) + (y-y2)*(y-y2) = r2*r2
//
//  (nIntX1,nIntY1),(nIntX2,nIntY2) 
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfTwoCircle(int x1,int y1,int r1,int x2,int y2,int r2,int& nIntX1,int& nIntY1,int& nIntX2,int& nIntY2);

//ԲĽ
//
//  ptCenter1,nRadius1 ԲĺͰ뾶
//  ptCenter2,nRadius2 ԲĺͰ뾶
//
//  lpptIntersection1,lpptIntersection2 
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfTwoCircle(POINT ptCenter1,int nRadius1,POINT ptCenter2,int nRadius2,LPPOINT lpptIntersection1,LPPOINT lpptIntersection2);

//ԲĽ
//
//  ptCenter1,nRadius1 ԲĺͰ뾶
//  ptCenter2,nRadius2 ԲĺͰ뾶
//
//  ptIntersection1,ptIntersection2 
//ֵ
//  =0,ûн
//  =1,һ
//  =2,
int IntOfTwoCircle(POINT ptCenter1,int nRadius1,POINT ptCenter2,int nRadius2,CPoint& ptIntersection1,CPoint& ptIntersection2);

//߶κߵĽ
//ر:
//  ú߶κеĸ߶εĽ,ֱߺеĸ߶εĽ!!!
//  μIntOfLinePolyline(...).
//
//  ptPointS,ptPointE ֱߵ
//  listPolyline 
//
//  listIntPoint 
//ֵ
//  
int IntOfLineSegmentPolyline(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,CList<CPoint,CPoint>& listIntPoint);
//IntOfLineSegmentPolyline(...),IntOfLineSegmentPolyline_Old(...)и(һ"case 2:")
int IntOfLineSegmentPolyline_Old(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,CList<CPoint,CPoint>& listIntPoint);

//ʸptPointSptPointEߵĽ!!!
//ر:
//  úʸеĸ߶εĽ,ֱ(ֱ߶)еĸ߶εĽ!!!
//  Ҫ󽻵߶ptPointS_ptPointEϻʸptPointSptPointEӳ
//  μIntOfLineSegmentPolyline(...)IntOfLinePolyline(...).
//
//  ptPointS,ptPointE ʸptPointSptPointE
//  listPolyline 
//
//  listIntPoint 
//ֵ
//  
int IntOfVectorLinePolyline(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,CList<CPoint,CPoint>& listIntPoint);

//ֱߺߵĽ!!!
//ر:
//  úֱߺеĸ߶εĽ,ֱ߶κеĸ߶εĽ!!!
//  μIntOfLineSegmentPolyline(...).
//
//  ptPointS,ptPointE ֱߵ
//  listPolyline 
//
//  listIntPoint 
//ֵ
//  
int IntOfLinePolyline(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,CList<CPoint,CPoint>& listIntPoint);

//ֱߺߵĽ!!!
//ر:
//  úֱߺеĸ߶εĽ,ֱ߶κеĸ߶εĽ!!!
//  μIntOfLineSegmentPolyline(...).
//
//  a,b,c ֱ߷ax+by+c=0
//  listPolyline 
//
//  listIntPoint 
//ֵ
//  
int IntOfLinePolyline(double a,double b,double c,CList<CPoint,CPoint>& listPolyline,CList<CPoint,CPoint>& listIntPoint);

//ֱߺͷӳߵĽ
//
//  ptPointS,ptPointE ֱߵ
//  listPolyline 
//  dLength ڼӳʱ
//
//  ptIntPoint 
//ֵ
//  
int IntOfLinePolylineExtendHead(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,double dLength,CPoint &ptIntPoint);
int IntOfLinePolylineExtendHead(double a,double b,double c,CList<CPoint,CPoint>& listPolyline,double dLength,CPoint &ptIntPoint);

//ֱߺβӳߵĽ
//
//  ptPointS,ptPointE ֱߵ
//  listPolyline 
//  dLength ڼӳʱ
//
//  ptIntPoint 
//ֵ
//  
int IntOfLinePolylineExtendTail(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline,double dLength,CPoint &ptIntPoint);
int IntOfLinePolylineExtendTail(double a,double b,double c,CList<CPoint,CPoint>& listPolyline,double dLength,CPoint &ptIntPoint);

//ߺߵĽ
//
//  listPolyline1 
//  listPolyline2 
//
//  listIntPoint ,listPolyline1ĳ˳ͷβ
//ֵ
//  
int IntOfTwoPolyline(CList<CPoint,CPoint>& listPolyline1,CList<CPoint,CPoint>& listPolyline2,CList<CPoint,CPoint>& listIntPoint);

//[20161229 syf]ߺߵĽ
//ر˵:
//  (1)úIntOfTwoPolyline(),жIntOfTwoLineSegment()ķֵʱ,{1,4,5},IntOfTwoPolyline()=1
//
//  listPolyline1 
//  listPolyline2 
//
//  listIntPoint ,listPolyline1ĳ˳ͷβ
//ֵ
//  
int IntOfTwoPolyline_101(CList<CPoint,CPoint>& listPolyline1,CList<CPoint,CPoint>& listPolyline2,CList<CPoint,CPoint>& listIntPoint);

//ƥֱ߶εĽ
//
//  ptPoint
//  dMaxError ƥ
//  ptPointS1_ptPointE1 ֱ߶1յ
//  ptPointS2_ptPointE2 ֱ߶2յ
//
//  ptIntersection 
//  dDistance ʵʾ
//ֵ
//  ֱ߶εĽptIntersectionptPointľ<=dMaxError,򷵻true.false.
BOOL FixPointIntOfTwoLineSegment(POINT ptPoint,double dMaxError,POINT ptPointS1,POINT ptPointE1,
                                 POINT ptPointS2,POINT ptPointE2,POINT& ptIntersection,double& dDistance);

//ƥ߶κԲĽ
//:
//  ptPoint
//  dMaxError ƥ
//  ptPointS,ptPointE ֱ߶εֹ
//  ptCenter Բ
//  nRadius 뾶
//
//  ptIntersection 
//  dDistance ʵʾ
//ֵ
//  ߶κԲĽptIntersectionptPointľ<=dMaxError,򷵻true.false.
BOOL FixPointIntOfLineSegmentCircle(POINT ptPoint,double dMaxError,POINT ptPointS,POINT ptPointE,
                                    POINT ptCenter,int nRadius,POINT& ptIntersection,double& dDistance);

//ƥԲĽ
//
//  ptPoint
//  dMaxError ƥ
//  ptCenter1,nRadius1 ԲĺͰ뾶
//  ptCenter2,nRadius2 ԲĺͰ뾶
//
//  ptIntersection 
//  dDistance ʵʾ
//ֵ
//  ԲĽptIntersectionptPointľ<=dMaxError,򷵻true.false.
BOOL FixPointIntOfTwoCircle(POINT ptPoint,double dMaxError,POINT ptCenter1,int nRadius1,
                            POINT ptCenter2,int nRadius2,POINT& ptIntersection,double& dDistance);

//ƥ߶κߵĽ
//
//  ptPoint
//  dMaxError ƥ
//  ptPointS,ptPointE ߶
//  listPolyline 
//
//  ptIntersection 
//  dDistance ʵʾ
//  nLocate  λ(nLocate)
//ֵ
//  ߶κߵĽptIntersectionptPointľ<=dMaxError,򷵻true.false.
BOOL FixPointIntOfLineSegmentPolyline(POINT ptPoint,double dMaxError,POINT ptPointS,
                                      POINT ptPointE,CList <CPoint,CPoint> &listPolyline,
                                      POINT &ptIntersection,double &dDistance,int& nLocate);

//ƥߵĽ
//
//  ptPoint
//  dMaxError ƥ
//  listPolyline1 1
//  listPolyline2 2
//
//  ptIntersection 
//  dDistance ʵʾ
//  nLocate  λ(nLocate)
//ֵ
//  ߵĽptIntersectionptPointľ<=dMaxError,򷵻true.false.
BOOL FixPointIntOfTwoPolyline(POINT ptPoint,double dMaxError,CList <CPoint,CPoint> &listPolyline1,
                              CList <CPoint,CPoint> &listPolyline2,POINT &ptIntersection,double &dDistance,int& nLocate);

//˵
//ȫ(ptPoint.x-nMaxError,ptPoint.y-nMaxError)__(ptPoint.x+nMaxError,ptPoint.y-nMaxError)
//֮߶εɾ
//:
//  ptPoint ĵ
//  nMaxError İ뾶
//  listPoint1 ˵ǰĵ
//:
//  listPoint2 ˵ĵ
void FilterPointOfListPoint(POINT ptPoint,int nMaxError,CList <CPoint,CPoint> &listPoint1,CList <CPoint,CPoint> &listPoint2);

//(nPx,nPy)ֱax+by+c=0ֱֱֱax+by+c=0Ľ(nFixX,nFixY)
//
//  (nPx,nPy)
//  a,b,c ֱߵϵ
//
//  (nFixX,nFixY)
void IntOfLinePointVL(int nPx,int nPy,double a,double b,double c,int& nFixX,int& nFixY);
void IntOfLinePointVL(double dPx,double dPy,double a,double b,double c,double& dFixX,double& dFixY);

//ptPoint1ֱax+by+c=0ֱֱֱax+by+c=0ĽptPoint2
//
//  ptPoint1
//  a,b,c ֱߵϵ
//
//  ptPoint2
void IntOfLinePointVL(CPoint ptPoint1,double a,double b,double c,CPoint& ptPoint2);

//ptPoint1ֱptPoint2_ptPoint3ֱֱֱptPoint2_ptPoint3ĽptPoint4
//
//  ptPoint1
//  ptPoint2,ptPoint3 ֱߵ
//
//  ptPoint4
void IntOfLinePointVL(CPoint ptPoint1,CPoint ptPoint2,CPoint ptPoint3,CPoint& ptPoint4);

//(x2,y2)_(x3,y3)ΪԳĶԳƵ
//;
//  (x1,y1) 
//  (x2,y2)_(x3,y3) Գ
//:
//  (nPx,nPy) ԳƵ
void SymmetryPoint(int x1,int y1,int x2,int y2,int x3,int y3,int& nPx,int& nPy);
//ptPoint2_ptPoint3ΪԳĶԳƵ
//;
//  ptPoint1 
//  ptPoint2_ptPoint3 Գ
//:
//  ptPoint4 ԳƵ
void SymmetryPoint(CPoint ptPoint1,CPoint ptPoint2,CPoint ptPoint3,CPoint &ptPoint4);
//ptPoint1_ptPoint2ΪԳĶԳƵ
//;
//  listPoint1 
//  ptPoint1_ptPoint2 Գ
//:
//  listPoint2 ԳƵ
void SymmetryPoint(CList<CPoint,CPoint> &listPoint1,CPoint ptPoint1,CPoint ptPoint2,CList<CPoint,CPoint> &listPoint2);
//ֱax+by+c=0ΪԳĶԳƵ
//;
//  listPoint1 
//  a,b,c Գֱ߷
//:
//  listPoint2 ԳƵ
void SymmetryPoint(CList<CPoint,CPoint> &listPoint1,double a,double b,double c,CList<CPoint,CPoint> &listPoint2);
void SymmetryPoint(CList<CDBLPoint,CDBLPoint> &listDBLPoint1,double a,double b,double c,CList<CDBLPoint,CDBLPoint> &listDBLPoint2);
//ֱax+by+c=0ΪԳĶԳƵ
//;
//  (x1,y1) 
//  a,b,c Գֱ߷
//:
//  (nPx,nPy) ԳƵ
void SymmetryPoint(int x1,int y1,double a,double b,double c,int& nPx,int& nPy);
void SymmetryPoint(double x1,double y1,double a,double b,double c,double& dPx,double& dPy);
//ֱax+by+c=0ΪԳĶԳƵ
//;
//  ptPoint1 
//  a,b,c Գֱ߷
//:
//  ptPoint2 ԳƵ
void SymmetryPoint(CPoint ptPoint1,double a,double b,double c,CPoint& ptPoint2);
void SymmetryPoint(CDBLPoint ptDBLPoint1,double a,double b,double c,CDBLPoint& ptDBLPoint2);

//ȷֱXļн,[0,2pi)֮
//:
//  (startx,starty) 
//  (endx,endy) յ
//ֵ:
//  н
double angle_2(int startx,int starty,int endx,int endy);
//[20170330 syf]
double angle_2(double startx,double starty,double endx,double endy);

//ȷֱXļн,[0,2pi)֮
//:
//  ptPointS 
//  ptPointE յ
//ֵ:
//  н
double angle_2(POINT ptPointS,POINT ptPointE);

//[20170330 syf]
double angle_2(CDBLPoint ptPointS,CDBLPoint ptPointE);

//ʸptPointS1ptPointE1ʱ뷽תʸptPointS2ptPointE2ķļн,[0,2pi)֮
//:
//  ptPointS1,ptPointE1 ʸptPointS1ptPointE1
//  ptPointS2,ptPointE2 ʸptPointS2ptPointE2
//ֵ:
//  н
double angle_2(POINT ptPointS1,POINT ptPointE1,POINT ptPointS2,POINT ptPointE2);

//[20170330 syf]
double angle_2(CDBLPoint ptPointS1,CDBLPoint ptPointE1,CDBLPoint ptPointS2,CDBLPoint ptPointE2);

//(x1,y1),(x2,y2)(x3,y3),ԼԲ(cx,cy),
//(x2,y2)(x1,y1)(x3,y3)м,ʱ뷽򻭻ʱ,
//(x1,y1),(x3,y3)յʱtrue,򷵻false
//ر˵:˴˵ʱָʾ,XΪ,YΪϵ˵˴˳ʱ
BOOL IsAnticlockwise(long x1,long y1,long x2,long y2,long x3,long y3,long cx,long cy);

//[20170330 syf]
BOOL IsAnticlockwise_Double(double x1,double y1,double x2,double y2,double x3,double y3,double cx,double cy);

///////////////////////// 㶨ԲʱԲĺͰ뾶 ///////////////////////////
// :(x1,y1),(x2,y2),(x3,y3)
// 㷨:
//     (x1,y1),(x2,y2)еL1,
//     (x2,y2),(x3,y3)еL2,
//     L1,L2Ľ.
// :
//   γԲfalse,
//   򷵻trueԲΪ(cx,cy),뾶=cr.
//     ʱ뷽򻭻ʱ,cr>0 (x1,y1),(x3,y3)յ,
//                        cr<0 (x3,y3),(x1,y1)յ.
// ر˵:˴˵ʱָʾ,ڶXΪ,
//          YΪϵ˵˴˳ʱ
////////////////////////////////////////////////////////////////////////////////
BOOL CircleCR(int x1,int y1,int x2,int y2,int x3,int y3,int& cx,int& cy,int& cr);

//[20170330 syf]
BOOL CircleCR(double x1,double y1,double x2,double y2,double x3,double y3,double& cx,double& cy,double& cr);

//Բһ뾶(ptCenterptPoint)Ľ
//
//  ptCenter Բ
//  nRadius 뾶
//  ptPoint 뾶ϵһ
//ֵ
//  
CPoint IntOfCircleRadial(CPoint ptCenter,int nRadius,CPoint ptPoint);

//׷ϷԽ߷: AX=D
//                                                               
//     a00       a01                                 x0      d0  
//     a10       a11       a12               0       x1      d1  
//               a21       a22      a23              x2      d2  
//                .         .        .               .       .   
//  A=             .         .        .          , X=.   , D=.   
//                  .         .        .             .       .   
//         0        an-2,n-3  an-2,n-2  an-2,n-1     xn-2    dn-2
//                            an-1,n-2  an-1,n-1     xn-1    dn-1
//                                                               
//:
//    a[] Խ߾Aһάa00,a01,a10,a11,a12,a21,a22,a23,...,(an-1,n-2),(an-1,n-1)
//    n ,Ľ
//    d[] Ҷ˵ĳ
//
//    ΨһʱTRUE,d[]ǷĽ.
//    򷵻FALSE.
BOOL Cetrd1(double *a,int n,double *d);

//½ϽǵԽ߷: AX=D
//                                                               
//     a00       a01                        a0n      x0      d0  
//     a10       a11       a12               0       x1      d1  
//               a21       a22      a23              x2      d2  
//                .         .        .               .       .   
//  A=             .         .        .          , X=.   , D=.   
//                  .         .        .             .       .   
//         0        an-2,n-3  an-2,n-2  an-2,n-1     xn-2    dn-2
//     an-1,0                 an-1,n-2  an-1,n-1     xn-1    dn-1
//                                                               
//:
//    a[] žAһάa00,a01,a0n,a10,a11,a12,0,a21,a22,a23,0,...,(an-1,0),(an-1,n-2),(an-1,n-1)
//    n ,Ľ
//    d[] Ҷ˵ĳ
//
//    ΨһʱTRUE,d[]ǷĽ.
//    򷵻FALSE.
BOOL Cetrd2(double *a,int n,double *d);

//ԸֵöBezier߽,߱ƽ.
//               1 -2  1 P1 
// P(t)=[t2 t 1]-2  2  0 p2 
//               1  0  0 p3 
//:
//  listSPֵ.
//  dMaxError (>=0.5)
//:
//  ϳɹtrue,
//    listFitPǸߵõıƽ.
//  򷵻false,listFitPеݺlistSPͬ
BOOL BezierCurve(CList<CPoint,CPoint>& listSP,double dMaxError,CList<CPoint,CPoint>& listFitP);

//˵: ݲ2Bezierϵһ
//:
//  (dX1,dY1),(dX2,dY2),(dX3,dY3)  2BezierƵ
//  dT T
//ֵ:
//  point dTӦĵ
CPoint BezierPoint(double dX1, double dY1, double dX2, double dY2, double dX3, double dY3, double dT);
//2BezierϸߵеĲֵ
//:
//  (dX1,dY1),(dX2,dY2),(dX3,dY3)  2BezierƵ
//  pointS,pointE ߷(㲻ͬ)
//ֵ:
//  еĲ
double BezierPointParam(double dX1, double dY1, double dX2, double dY2, double dX3, double dY3, CPoint pointS,CPoint pointE);

//Ըֵò(ҳ)߽,߱ƽ.
//:
//  listSPֵ.
//  bClose =fasle,, =true պ(ʱҪֵͷβʾͬһ).
//  dMaxError (>=0.5)
//  bNatural =true ɶ˱߽,=false ߽߱
//:
//  ϳɹtrue,
//    listFitPǸߵõıƽ.
//    ر˵:պߵıƽlistFitPͷβ겻ͬ!!!
//  򷵻false.
BOOL SplineCurve(CList<CPoint,CPoint>& listSP,BOOL bClose,double dMaxError,CList<CPoint,CPoint>& listFitP,BOOL bNatural=true);

//Ըֵò(ҳ)߽,߱ƽ.
//:
//  listSPֵ.
//  bClose =fasle,, =true պ(ʱҪֵͷβʾͬһ).
//  dMaxError (>=0.5)
//  bTangentH  =true 
//  ptTangentH  ʱϵĵ
//  bTangentT  =true յ
//  ptTangentT  յʱϵĵ
//  bNatural =true ɶ˱߽,=false ߽߱
//:
//  ϳɹtrue,
//    listFitPǸߵõıƽ.
//    ر˵:պߵıƽlistFitPͷβ겻ͬ!!!
//  򷵻false.
BOOL SplineCurve(CList<CPoint,CPoint>& listSP,BOOL bClose,double dMaxError,CList<CPoint,CPoint>& listFitP,BOOL bTangentH,CPoint ptTangentH,BOOL bTangentT,CPoint ptTangentT,BOOL bNatural);

//ԸֵBezier߻(ҳ)߽,߱ƽ.
//ر˵:
//    ֵĸ3ǿʱʹBezier,ʹ
//:
//  listSPֵ.
//  bClose =fasle,, =true պ(ʱҪֵͷβʾͬһ).
//  dMaxError (>=0.5)
//  bNatural =true ɶ˱߽,=false ߽߱
//:
//  ϳɹtrue,
//    listFitPǸߵõıƽ.
//    ر˵:պߵıƽlistFitPͷβ겻ͬ!!!
//  򷵻false.
BOOL CurveFit(CList<CPoint,CPoint>& listSP,BOOL bClose,double dMaxError,CList<CPoint,CPoint>& listFitP,BOOL bNatural=true);
//ԸֵBezier߻(ҳ)߽,߱ƽ.
//ر˵:
//    ֵĸ3ֹûĿʱʹBezier,ʹ
//:
//  listSPֵ.
//  bClose =fasle,, =true պ(ʱҪֵͷβʾͬһ).
//  dMaxError (>=0.5)
//  bTangentH  =true 
//  ptTangentH  ʱϵĵ
//  bTangentT  =true յ
//  ptTangentT  յʱϵĵ
//  bNatural =true ɶ˱߽,=false ߽߱
//:
//  ϳɹtrue,
//    listFitPǸߵõıƽ.
//    ر˵:պߵıƽlistFitPͷβ겻ͬ!!!
//  򷵻false.
BOOL CurveFit(CList<CPoint,CPoint>& listSP,BOOL bClose,double dMaxError,CList<CPoint,CPoint>& listFitP,BOOL bTangentH,CPoint ptTangentH,BOOL bTangentT,CPoint ptTangentT,BOOL bNatural);

//NURBSߵʵʵ(ǾB)
//ر˵:
//  API,Ҫ
//:
//  listSP  ֵ,ϵ:ȿֽϵ,ֿ豸ϵ
//  bClose  =true պ,=false 
//:
//  listFitP  ߵõıƽ,պ,ôͷβ겻ͬ!!!
//ֵ:
//  =true ɹ,=false ʧ
BOOL CurveFit_NURBS(CList<CPoint,CPoint>& listSP, CList<CPoint,CPoint>& listFitP, BOOL bClose = FALSE);

//󿪿ߵĿƵ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listFitPoint  ԭʼ
//  dMaxError  
//:
//  listCtrlPoint  Ƶ
BOOL GetControlPointOfOpenCurve(int iDPMM,CList<CRPGrade_Point,CRPGrade_Point> &listFitPoint,double dMaxError,CList<CRPGrade_Point,CRPGrade_Point> &listCtrlPoint);

//󿪿ߵĿƵ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listFitPoint  ԭʼ
//  dMaxError  
//  listCtrlPoint  еĿƵ
//:
//  listCtrlPoint  Ƶ,listCtrlPointյ겻ͬ
BOOL GetControlPointOfOpenCurve(int iDPMM,CList<CPoint,CPoint> &listFitPoint,double dMaxError,CList<CPoint,CPoint> &listCtrlPoint);

//պߵĿƵ,listFitPointյ겻ͬ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listFitPoint  ԭʼ
//  dMaxError  
//:
//  listCtrlPoint  Ƶ,listCtrlPointյ겻ͬ
BOOL GetControlPointOfCloseCurve(int iDPMM,CList<CRPGrade_Point,CRPGrade_Point> &listFitPoint,
                                 double dMaxError,CList<CRPGrade_Point,CRPGrade_Point> &listCtrlPoint);

//պߵĿƵ,listFitPointյ겻ͬ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listFitPoint  ԭʼ
//  dMaxError  
//  listCtrlPoint  еĿƵ
//:
//  listCtrlPoint  Ƶ
BOOL GetControlPointOfCloseCurve(int iDPMM,CList<CPoint,CPoint> &listFitPoint,double dMaxError,CList<CPoint,CPoint> &listCtrlPoint);

//ڵlistPointOldеĵlistPointNewСе
//:
//  listPointOld 
//  listPointNew 
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//:
//  dMaxDistance 
//ֵ:
//  ҵ
CPoint MaxDistancePoint(int iDPMM,CList<CPoint,CPoint> &listPointOld,CList<CPoint,CPoint> &listPointNew,double &dMaxDistance);

//ж϶εͷβķ
//:
//  listPolygon εĵ.
//ֵ:
//  =true ʱ(ʾϵ),=false ˳ʱ(ʾϵ)
BOOL IsAnticlockwise(CList<CPoint,CPoint>& listPolygon);

//ʹķ䷴,ͷ.
//:
//  listPoint1 .
//:
//  listPoint2
void Reverse(CList<CPoint,CPoint>& listPoint1,CList<CPoint,CPoint>& listPoint2);
//ʹķ䷴,βͷ.
//:
//  listPoint1 .
//:
//  listPoint2
void ReverseT2H(CList<CPoint,CPoint>& listPoint1,CList<CPoint,CPoint>& listPoint2);

//ת
//:
//  listPoint1  תĵ
//  x  ˮƽתĶԳ
//  bHorizontal  =true ˮƽת
//  y  ֱתĶԳ
//  bVertical  =true ֱת
//:
//  listPoint2  ѷתĵ
void Flip(CList<CPoint,CPoint> &listPoint1,int x,BOOL bHorizontal,int y,BOOL bVertical,CList<CPoint,CPoint> &listPoint2);
//ת
//:
//  ptPoint  תĵ
//  x  ˮƽתĶԳ
//  bHorizontal  =true ˮƽת
//  y  ֱתĶԳ
//  bVertical  =true ֱת
//:
//  ptPoint  ѷתĵ
void Flip(CPoint &ptPoint,int x,BOOL bHorizontal,int y,BOOL bVertical);

//ptPointֱax+by+c=0ľ
double DistanceOfPL(CPoint ptPoint,double a,double b,double c);
//ptPointֱptPointL1_ptPointL2ľ
double DistanceOfPL(CPoint ptPoint,CPoint ptPointL1,CPoint ptPointL2);
//ptPoint߶ptPointL1_ptPointL2ľ
double DistanceOfPLineSegment(CPoint ptPoint,CPoint ptPointL1,CPoint ptPointL2);
//ptPointlistPolyline
double DistanceOfPPloyline(CPoint ptPoint,CList<CPoint,CPoint> &listPolyline);

//ȥͬĵ,ͬĵֻһ
void RemoveSamePointOfPolygon(CList<CPoint,CPoint>& listPoint);
//[20170330 syf]
void RemoveSamePointOfPolygon(CDBLPointList& listPoint);

//ȥͬĵ,ͬĵֻһ
//RemoveSamePointOfPolygonͬβͬʱȥһ
void RemoveSamePointOfPolyline(CList<CPoint,CPoint>& listPoint);

//[20170330 syf]
void RemoveSamePointOfPolyline(CDBLPointList& listPoint);

//ɾ<=dMinLengthĵ
void Remove2NearPointOfPolygon(CList<CPoint,CPoint>& listPoint,double dMinLength);
//ɾ<=dMinLengthĵ
void Remove2NearPointOfPolyline(CList<CPoint,CPoint>& listPoint,double dMinLength);

//20160602 XQ ɾе<=dMinLengthĵ
void RemoveAll2NearPointOfPolyline(CList<CPoint,CPoint>& listPoint,double dMinLength);

//еһ.
//δӵptPointS˳ʱ(ʾϵ)ƶptPointE.
//ptPointS==ptPointE,ǴptPointSptPointE
//ر˵:
//  ptPointS,ptPointEһǶεĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolygon εĵ.
//  ptPointS,ptPointE߶εֹ.
//:
//  listPolyline ߵĵ
//ֵ:
//  true ɹ,false.
BOOL PolylineOfPolygon(int iDPMM,CList<CPoint,CPoint>& listPolygon,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline);

//еһ.
//δӵptPointSȾptPointMٵptPointE.
//ر˵:
//  ptPointS,ptPointM,ptPointEһǶεĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolygon εĵ.
//  ptPointS,ptPointE߶εĶ˵.
//  ptPointM м
//:
//  listPolyline ߵĵ
//ֵ:
//  true ɹ,false.
BOOL PolylineOfPolygon(int iDPMM,CList<CPoint,CPoint>& listPolygon,CPoint ptPointS,CPoint ptPointM,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline);

//еһ.
//δӵptPointSǰƶptPointE.ptPointS==ptPointEǴptPointSʼ
//ptPointE.
//ر˵:
//  ptPointS,ptPointEһǶεĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolygon εĵ.
//  ptPointS,ptPointE߶εֹ.
//:
//  listPolyline ߵĵ
//ֵ:
//  true ɹ,false.
BOOL PrevPolylineOfPolygon(int iDPMM,CList<CPoint,CPoint>& listPolygon,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline);

//еһ.
//δӵptPointSƶptPointE.ptPointS==ptPointEǴptPointSʼ
//ptPointE.
//ر˵:
//  ptPointS,ptPointEһǶεĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolygon εĵ.
//  ptPointS,ptPointE߶εֹ.
//:
//  listPolyline ߵĵ
//ֵ:
//  true ɹ,false.
BOOL NextPolylineOfPolygon(int iDPMM,CList<CPoint,CPoint>& listPolygon,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline);

//ߵĵptPointSptPointE֮һ.
//ر˵:
//  ptPointS,ptPointEһߵĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolyline1 ԭߵĵ.
//  ptPointS,ptPointE߶εֹ.
//:
//  listPolyline2 ߵĵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfPolyline(int iDPMM,CList<CPoint,CPoint>& listPolyline1,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline2);

//ߵptPointE֮һ.
//ر˵:
//  ptPointEһߵĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolyline1 ԭߵĵ.
//  ptPointE߶εյ.
//:
//  listPolyline2 ߵĵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfPolylineS(int iDPMM,CList<CPoint,CPoint>& listPolyline1,CPoint ptPointE,CList<CPoint,CPoint>& listPolyline2);

//ߵĵptPointSյ֮һ.
//ر˵:
//  ptPointSһߵĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolyline1 ԭߵĵ.
//  ptPointE߶εյ.
//:
//  listPolyline2 ߵĵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfPolylineE(int iDPMM,CList<CPoint,CPoint>& listPolyline1,CPoint ptPointS,CList<CPoint,CPoint>& listPolyline2);

//ߵĴӵptPointSʼ,ptPointM˵(յ)֮һ.
//ر˵:
//  ptPointS,ptPointMһǶεĶ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolyline1 ԭߵĵ.
//  ptPointS,ptPointM߶εֹ.
//:
//  listPolyline2 ߵĵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfPolylineSM(int iDPMM,CPoint ptPointS,CPoint ptPointM,CList<CPoint,CPoint>& listPolyline1,CList<CPoint,CPoint>& listPolyline2);

//ξptArcPointS,ptArcPointM,ptArcPointEԲĶαʾ
//:
//  ptCirclePointS,ptCirclePointM,ptCirclePointE Բξĵ
//  dMaxError ƽ
//:
//  listPolygon ε
//ֵ:
//  ɹtrue,false.
BOOL PolygonOfCircle(CPoint ptCirclePointS,CPoint ptCirclePointM,CPoint ptCirclePointE,CList<CPoint,CPoint>& listPolygon,double dMaxError=0.5);

//[20170330 syf]
BOOL PolygonOfCircle(CDBLPoint ptCirclePointS,CDBLPoint ptCirclePointM,CDBLPoint ptCirclePointE,CDBLPointList& listPolygon,double dMaxError=0.5);

//Բʱ뷽(ʾ)Ķαʾ.
//:
//  ptCenter  Բ
//  ptCirclePointS Բ
//  dMaxError ƽ
//:
//  listPolygon ε
//ֵ:
//  ɹtrue,false.
BOOL PolygonOfCircle(CPoint ptCenter,CPoint ptCirclePointS,CList<CPoint,CPoint>& listPolygon,double dMaxError=0.5);

//[20170330 syf]
BOOL PolygonOfCircle(CDBLPoint ptCenter,CDBLPoint ptCirclePointS,CDBLPointList& listPolygon,double dMaxError=0.5);

//ξptArcPointS,ptArcPointM,ptArcPointEĻߵ߱ʾ.
//:
//  ptArcPointS,ptArcPointM,ptArcPointE ξĵ
//  dMaxError ƽ
//:
//  listPolyline ߵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfArc(CPoint ptArcPointS,CPoint ptArcPointM,CPoint ptArcPointE,CList<CPoint,CPoint>& listPolyline,double dMaxError=0.5);

//[20170330 syf]
BOOL PolylineOfArc(CDBLPoint ptArcPointS,CDBLPoint ptArcPointM,CDBLPoint ptArcPointE,CDBLPointList& listPolyline,double dMaxError=0.5);

//ߵ߱ʾ.
//:
//  ptCenter Բ
//  ptArcPointS 
//  dAngle νǶ,>=0 ʱ(ʾϵ),<0 ˳ʱ(ʾϵ),λ:
//  dMaxError ƽ
//:
//  listPolyline ߵ
//ֵ:
//  ɹtrue,false.
BOOL PolylineOfArc(CPoint ptCenter,CPoint ptArcPointS,double dAngle,CList<CPoint,CPoint>& listPolyline,double dMaxError=0.5);

//[20170330 syf]
BOOL PolylineOfArc(CDBLPoint ptCenter,CDBLPoint ptArcPointS,double dAngle,CDBLPointList& listPolyline,double dMaxError=0.5);

//жһǷڶ
//:
//  point 
//  lpPoints[0]...lpPoints[nCount-1] εĶ
//ֵ:
//  =true ڶ
//  =false 㲻ڶ
BOOL PointInPolygon(POINT point,LPPOINT lpPoints,int nCount);

//жһǷڶ
//:
//  point 
//  listPolygon εĵ
//ֵ:
//  =true ڶ
//  =false 㲻ڶ
BOOL PointInPolygon(POINT point,CList<CPoint,CPoint>& listPolygon);

//ֱP1P2nDƽֱߵķ,ֱʸP1P2(ʾϵ)
//Ҫ˵:
//  ڳǰXΪ,YΪϵ,ֱʸP1P2Ҳ
//:
//  (nX1,nY1),(nX2,nY2) ֱP1P2
//  nD ֱߺ͸ֱP1P2ľ
//:
//  (nX1,nY1),(nX2,nY2)ͬһʱtrue, a,b,c õֱ:ax+b*y+c=0;
//  (nX1,nY1),(nX2,nY2)ͬһʱfasle.
BOOL LineParallel(int nX1,int nY1,int nX2,int nY2,int nD,double& a,double& b,double& c);

//ֱP1P2nDƽֱߵķ,ֱʸP1P2(ʾϵ)
//Ҫ˵:
//  ڳǰXΪ,YΪϵ,ֱʸP1P2Ҳ
//:
//  ptPoint1,ptPoint2 ֱP1P2
//  nD ֱߺ͸ֱP1P2ľ
//:
//  ptPoint1,ptPoint2ͬһʱtrue, a,b,c õֱ:ax+b*y+c=0
//  ptPoint1,ptPoint2ͬһʱfasle.
BOOL LineParallel(CPoint ptPoint1,CPoint ptPoint2,int nD,double& a,double& b,double& c);

//һı߽
CRect GetRectOfListPoint(CList<CPoint,CPoint>& listPoint);

//ĹԼ
//
//  nNum1,nNum2 ҪԼ
//ֵ:
//  nNum1,nNum2ĹԼ(nNum1,nNum20ʱ1)
int CommomDivisor(int nNum1,int nNum2);

//жһǷ֮
//:
//  ptPoint
//  ptPointS
//  ptPointE
//ֵ:
//  ptPointptPointS_ptPointE֮䷵true,false.
BOOL BetweenTwoPoint(CPoint ptPoint,CPoint ptPointS,CPoint ptPointE);

//жһǷߵ֮
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  ptPoint
//  ptPointS
//  ptPointE
//  listPolyline1
//:
//  listPolyline2 ptPointS_ptPointE֮.
//ֵ:
//  ptPointߵptPointS_ptPointE֮䷵true,false.
BOOL BetweenTwoPointAtPolyline(int iDPMM,CPoint ptPoint,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint> &listPolyline1,CList<CPoint,CPoint> &listPolyline2);

//ĳ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  ptPointS,ptPointE ϵ
//  listPolyline 
//ֵ:
//  ĳ
int Get2PLengthOfPolyline(int iDPMM,CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint> &listPolyline);

//ߵĳ
//:
//  listPolyline 
//ֵ:
//  ߳
int GetLengthOfPolyline(CList<CPoint,CPoint> &listPolyline);

//ߵĳ
//:
//  listPolyline 
//:
//  dLength ߳ȵ˫ֵ
//ֵ:
//  ߳
int GetLengthOfPolyline(CList<CPoint,CPoint> &listPolyline,double &dLength);

//εĳ
//:
//  listPolygon 
//ֵ:
//  γ
int GetLengthOfPolygon(CList<CPoint,CPoint> &listPolygon);

//εĳ
//:
//  listPolygon 
//:
//  dLength γȵ˫ֵ
//ֵ:
//  γ
int GetLengthOfPolygon(CList<CPoint,CPoint> &listPolygon,double &dLength);

//
//ֵ:
//  ľ
int TwoPointLength(CPoint ptPoint1,CPoint ptPoint2);

//
//:
//  dLength ˫ֵ
//ֵ:
//  ľ
int TwoPointLength(CPoint ptPoint1,CPoint ptPoint2,double &dLength);

//
double TwoPointLength(CDBLPoint pDBLPoint1,CDBLPoint pDBLPoint2);

//жĳ
//:
//  ptPoint 
//ֵ:
//  1:1,2:2,3:3,4:4
int GetQuadrant(int x,int y);

//б߽ضϵĲȥ
//úڼƬߺи
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolygon 
//  listPolyline 
//:
//  listPolygon 
//ֵ:
//  true ɹ,false.
BOOL PolygonRemovePolyline(int iDPMM,CList<CPoint,CPoint> &listPolygon,CList<CPoint,CPoint> &listPolyline);

//listPointptPointS_ptPointEͬ(ptPointSptPointE),ҾptPointEĵptPoint
BOOL GetEquidireectionalPoint(CPoint ptPointS,CPoint ptPointE,CList<CPoint,CPoint> &listPoint,CPoint &ptPoint);

//ж(ptPoint1,ptPoint2)ǷֱptPointLS_ptPointLEͬ
//:
//  ptPoint1,ptPoint2 
//  ptPointLS,ptPointLE  ֱߵ
//ֵ:
//  true ͬ,false 
BOOL IsSameSide(CPoint ptPoint1,CPoint ptPoint2,CPoint ptPointLS,CPoint ptPointLE);

//жϵlistPointǷֱptPointLS_ptPointLEͬ
//:
//  listPoint 
//  ptPointLS,ptPointLE  ֱߵ
//ֵ:
//  true ͬ,false 
BOOL IsSameSide(CList<CPoint,CPoint> &listPoint,CPoint ptPointLS,CPoint ptPointLE);

//жƽеֱptPoint1_ptPoint2ptPoint3_ptPoint4,
//ʸptPoint1ptPoint2ptPoint3ptPoint4Ƿͬ.
//ر˵:20091111ǰҪptPoint1_ptPoint2ptPoint3_ptPoint4ƽ.֮ĳʸptPoint1ptPoint2ptPoint3ptPoint4ļнǲһָǶ
//:
//  ptPoint1
//  ptPoint2
//  ptPoint3
//  ptPoint4
//  dCosMaxAngle  жʸptPoint1ptPoint2ptPoint3ptPoint4ͬн,(ԭĬֵΪ1ȵ,20130827֮Ҫֵ)
//ֵ:
//  true ͬ,false ෴.
BOOL IsSameDirection(CPoint ptPoint1,CPoint ptPoint2,CPoint ptPoint3,CPoint ptPoint4,double dCosMaxAngle);

//[20130827]ָ20091111֮ǰĺ
//  Ϊھ,Ѿƽе,ֻҪжǵķǷͬ,ʹýǶж
//  ޸ɺ׿е<<S134211K00.dgs>>ļ,м101汾ʱ,ʸĽ,ʹøúжʱ(Ĭ1ȵֵ)жʧ,ΪǶ=1.83
BOOL IsSameDirection(CPoint ptPoint1,CPoint ptPoint2,CPoint ptPoint3,CPoint ptPoint4);

//жϵptPointǷھ(ptPoint1,ptPoint2)
//:
//  ptPoint 
//  ptPoint1,ptPoint2 ζԽ
//ֵ:
//  true ھ,false ھ
BOOL PointInRect(CPoint ptPoint,CPoint ptPoint1,CPoint ptPoint2);

//ַСõ0Сȥ
void TrimAfterDot0(CString &strNum);
//ַ1ַǰĻسȥ
CString TrimHeadCRLF(CString string);
//ַ1ַĻسȥ
CString TrimTailCRLF(CString string);

//жptPointǷʸptPointSptPointE(ʾ)
//ֵ:
//  =true (ʾ)ʸptPointSptPointE,=false ұ(ʾ)
BOOL IsLeftPoint(CPoint ptPoint,CPoint ptPointS,CPoint ptPointE);
//жptPointǷڶ(ʸǶε㵽յ)(ʾ)
//ֵ:
//  =true (ʾ)ڶ,=false ұ(ʾ)
BOOL IsLeftPoint(CPoint ptPoint,CList<CPoint,CPoint> &listPolyline);

//ľ
//:
//  ptPoint1
//  ptPoint2
//ֵ:
//  ľ
CRect RectOfContainTowPoint(CPoint ptPoint1,CPoint ptPoint2);

//ľ
//:
//  listPolyline 
//ֵ:
//  ľ
CRect RectOfPolyline(CList<CPoint,CPoint> &listPolyline);

//Բľ,Բָʱ뷽(ʾ,XΪ,YΪ,˳ʱ뷽)㵽յĲ
//:
//  ptLeftUp,ptRightDown Բ޶εϽǺ½(ʾ)
//  ptPointS,ptPointE Բյ
//ֵ:
//  Բľ
CRect RectOfContainArc(CPoint ptLeftUp,CPoint ptRightDown,CPoint ptPointS,CPoint ptPointE);

//ռõС
CSize StringSize(LOGFONT lfFont,CString string);
//ռõС
CSize StringSize(CDC *pDC,CString string);
//ռõС
CSize StringSize(CDC *pDC,CString string,int &nLines);
//ռõ
//:
//  lfFont ʾ
//  string ʾ
//  ptLU ʾϽλ
//  dScale ʱҪĸ߶ȡСı,ҪΪ˷ֹ߶ȡȵֵ̫㳬
//:
//  ptLD ½λ
//  ptRU Ͻλ
//  ptRD ½λ
//ֵ:
//  ռõС
CSize StringRgnLU(LOGFONT lfFont,CString string,CPoint &ptLU,CPoint &ptLD,CPoint &ptRU,CPoint &ptRD,double dScale=1.0);
//ռõ
//:
//  lfFont ʾ
//  string ʾ
//  ptLD ʾ½λ
//  dScale ʱҪĸ߶ȡСı,ҪΪ˷ֹ߶ȡȵֵ̫㳬
//:
//  ptLU Ͻλ
//  ptRU Ͻλ
//  ptRD ½λ
//ֵ:
//  ռõС
CSize StringRgnLD(LOGFONT lfFont,CString string,CPoint &ptLU,CPoint &ptLD,CPoint &ptRU,CPoint &ptRD,double dScale=1.0);
//ȡstring
int StringLines(CString string);
//ȡstringnLineIndexеַ(ʼеnLineIndexΪ0)
CString GetSubString(CString string,int nLineIndex);

//ε
//:
//  listPolygon  ε
double AreaOfPloygon(CList<CPoint,CPoint> &listPolygon);

//ж߶κ;Ƿཻ
//:
//  rect  
//  ptPointS_ptPointE ߶
//:
//  ptPointS,ptPointE ȡ߶(ptPointS_ptPointE)
//ֵ:
//  true ߶κ;ཻ, false ߶κ;βཻ.
BOOL IntersectLineRect(CRect rect,CPoint &ptPointS,CPoint &ptPointE);

//ж߶κ;Ƿཻ
//:
//  rect  
//  ptPointS_ptPointE ߶
//:
//  ptPointS,ptPointE ȡ߶(ptPointS_ptPointE)
//ֵ:
//  true ߶κ;ཻ, false ߶κ;βཻ.
BOOL IntersectLineRect(CRect rect,int &nXS,int &nYS,int &nXE,int &nYE);

//жߺ;Ƿཻ
//:
//  rect  
//  listPolyline 
//ֵ:
//  true ߺ;ཻ, false ߺ;βཻ.
BOOL IntersectPolylineRect(CList<CPoint,CPoint> &listPolyline,CPoint ptPointS,CPoint ptPointE);

//жϾǷԿѡ
//:
//    rect ѡľ
//    listPolyline 
//ֵ:
//    true Կѡ
//    false οѡ
BOOL IntersectPolylineRect(CRect rect,CList<CPoint,CPoint> &listPolyline);

//ڵlistPoint,ͷβ,жptPoint1ǷptPoint2ǰ(һֱǰ)
//ע:ptPoint1,ptPoint2ڵ,뵽.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPoint
//  ptPoint1
//  ptPoint2
//ֵ:
//  true   ptPoint1ptPoint2ǰ,
//  false  ptPoint1ptPoint2ǰ.
BOOL IsPrevPoint(int iDPMM,CList<CPoint,CPoint> &listPoint,CPoint ptPoint1,CPoint ptPoint2);

//20140504 XQ ptPointOԭ,ptExtendptExtendToPointʱ,ptPointOldӦptPointNew
//úͬʱҸߺҳ
void Extend(CPoint ptPointO,CPoint ptExtend,CPoint ptExtendToPoint,CPoint ptPointOld, CPoint &ptPointNew);

//ptPointOԭ,ptExtendptExtendToPointʱ,listPointOldӦlistPointNew
//úͬʱҸߺҳ
void Extend(CPoint ptPointO,CPoint ptExtend,CPoint ptExtendToPoint,CList<CPoint,CPoint> &listPointOld,CList<CPoint,CPoint> &listPointNew);
//ptPointOԭ,ptExtendptExtendToPointʱ,listPointOldӦlistPointNew
//úҳ
void ExtendInWidth(CPoint ptPointO,CPoint ptExtend,CPoint ptExtendToPoint,CList<CPoint,CPoint> &listPointOld,CList<CPoint,CPoint> &listPointNew);

//ҵlistPointptPointĵ
CPoint NearestPoint(CPoint ptPoint,CList<CPoint,CPoint> &listPoint,int &nDistance);

//ҵlistPoint1ĵlistPoint2ĵ
//:
//    listPoint1
//    listPoint2
//:
//    ptPoint1  õlistPoint1
//    ptPoint2  õlistPoint2
//ֵ:
//    ptPoint1ptPoint2ľ
int NearestPoint(CList<CPoint,CPoint> &listPoint1,CList<CPoint,CPoint> &listPoint2,CPoint &ptPoint1,CPoint &ptPoint2);

//ĳһĴax+by+c=0
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPolyline
//  ptPoint
//  dMinLength ȷߵ̾
//:
//  a,b,c ֱ߷
BOOL VerticalLineOfPloyline(int iDPMM,CList<CPoint,CPoint> &listPolyline,CPoint ptPoint,double dMinLength,double &a,double &b,double &c);
BOOL VerticalLineOfPloygon(int iDPMM,CList<CPoint,CPoint> &listPolygon,CPoint ptPoint,double dMinLength,double &a,double &b,double &c);

//ĳһax+by+c=0
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
BOOL TangentOfPloyline(int iDPMM,CList<CPoint,CPoint> &listPolyline,CPoint ptPoint,double dMinLength,double &a,double &b,double &c);
BOOL TangentOfPloygon(int iDPMM,CList<CPoint,CPoint> &listPolyline,CPoint ptPoint,double dMinLength,double &a,double &b,double &c);

//иʱԾ
//:
//  listRectOld  ûľ
//  nDistance С
//:
//  listRectNew  źľ
void CuttingSort(CList<CRect,CRect> &listRectOld,int nDistance,CList<CRect,CRect> &listRectNew);

//һµγɵ¾
//:
//  ptPoint µ
//  nLeft,nTop,nRight,nBottom ɵľ
//:
//  nLeft,nTop,nRight,nBottom µľ
void GetNewRect(CPoint ptPoint,int &nLeft,int &nTop,int &nRight,int &nBottom);

//жϵǷһֱ
//:
//  listPoint  
//  dMaxError  ߶
//ֵ:
//  true һֱ
BOOL AllPointAtLine(CList<CPoint,CPoint> &listPoint,double dMaxError);

//ˮƽֱ
//ֱptPointS_ptPointEˮƽֱߵĽǶСdMaxAngle,ptPointEˮƽֱϵptPointHV
//:
//  ptPointS,ptPointE  ֱߵ
//  dMaxAngle  Ƕ,λ:
//:
//  ptPointHV 
//ֵ:
//  true ڸĽǶˮƽֱ
BOOL HVLine(CPoint ptPointS,CPoint ptPointE,double dMaxAngle,CPoint &ptPointHV);

//ߵĿƵ.
//:
//  iDPMM  []ȷֱ(һڲλΪ1/iDPMM)
//  listPoint
//    
//  listCtrl
//    [][]Ƶ,Ƶɹ,ôʹøòЧЧ
//  dSplineError
//    ʱ
//  dMaxError
//    Ƶʱ
//  (bHeadTangent,ptHeadTangent)
//    bHeadTangent=TRUE,ǰߵ,ʱptHeadTangentЧ;bHeadTangent=FALSE,ûǰߵ,ʱptHeadTangentֵ
//  (bTailTangent,ptTailTangent)
//    bTailTangent=TRUE,кߵ,ʱptTailTangentЧ;bTailTangent=FALSE,ûкߵ,ʱptTailTangentֵ
//  bNatrual
//    =TRUE,Ȼ;=FALSE,,20170406 syf,ĬֵΪtrue
//  bExactSolution
//    =TRUE,⾫ȷ;=FALSE,⾫ȷ,ôԷŴֵ
BOOL CalculateSplineCtrlPoint(int iDPMM,CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listCtrl, double dSplineError, double dMaxError,
                              BOOL bHeadTangent = FALSE,CPoint ptHeadTangent = CPoint(0,0),BOOL bTailTangent = FALSE,
                              CPoint ptTailTangent = CPoint(0,0),BOOL bNatrual = TRUE, BOOL bExactSolution = TRUE);

//ÿһεȷַߵĿƵ(segment divide)
//:
//  listPoint
//    
//  listCtrl
//    [][]Ƶ,Ƶɹ,ôʹøòЧЧ
//  dSplineError
//    ʱ
//  dMaxError
//    Ƶʱ
//  (bHeadTangent,ptHeadTangent)
//    bHeadTangent=TRUE,ǰߵ,ʱptHeadTangentЧ;bHeadTangent=FALSE,ûǰߵ,ʱptHeadTangentֵ
//  (bTailTangent,ptTailTangent)
//    bTailTangent=TRUE,кߵ,ʱptTailTangentЧ;bTailTangent=FALSE,ûкߵ,ʱptTailTangentֵ
//  bNatrual
//    =TRUE,Ȼ;=FALSE,,20170406 syf,ĬֵΪtrue
//  bExactSolution
//    =TRUE,⾫ȷ;=FALSE,⾫ȷ,ôԷŴֵ
//  dMaxCtrlPointDistance
//    Ƶ
BOOL CalculateSplineCtrlPoint_SD(CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listCtrl, double dSplineError, double dMaxError, double dMaxCtrlPointDistance,
                                 BOOL bHeadTangent = FALSE,CPoint ptHeadTangent = CPoint(0,0),BOOL bTailTangent = FALSE,
                                 CPoint ptTailTangent = CPoint(0,0),BOOL bNatrual = TRUE, BOOL bExactSolution = TRUE);

//ľ
double DistanceOfTwoList(CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2);

//һһľ.
double DistanceFromListToList(CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2);

//һ㵽һľ.
double DistanceFromPointToList(CPoint point, CList<CPoint,CPoint>& listPoint);
double DistanceFromPointToList(CPoint point, CPoint* pt, int nArray);

//ptInt߶ptSptEϵĲֵ
double PointToParam(CPoint& ptInt, CPoint& ptS, CPoint& ptE);

//㵽һ߶εĴ.
void GetVerticalPoint(CPoint& ptS, CPoint& ptE, CPoint& ptRes, CPoint& ptDes);

//㵽һ߶εĴ.
void GetVerticalPoint(CDBLPoint ptDBLPointS, CDBLPoint ptDBLPointE, CDBLPoint ptInput, CDBLPoint& ptOutput);

//ж߶Ƿƽ
BOOL IsParallel(CPoint& ptS0, CPoint& ptE0, CPoint& ptS1, CPoint& ptE1);

//һƵ.
BOOL AddOneCtrlPoint(CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listCtrl);

//ݿƵָ.
void DivideListAccordingToCtrlList(CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listCtrl, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& arrayList);

//Ԫеֵ
//:
//  type
//    Ԫ
//  listType
//    
//ֵ:
//  >=0  Ԫ,ֵ0ʼ
//  =-1  Ԫز
template<class TYPE,class ARG_TYPE>
int FindIndex(TYPE type, CList<TYPE,ARG_TYPE>& listType)
{
  POSITION pos;
  int iResult, i;

  iResult = -1;
  i = 0;
  pos = listType.GetHeadPosition();
  while (pos != NULL)
  {
    if (listType.GetAt(pos) == type)
    {
      iResult = i;
      break;
    }
    else
    {
      listType.GetNext(pos);
      i++;
    }
  }

  return iResult;
}

//Ԫеֵ
//:
//  type
//    Ԫ
//  (p,nArray)
//    鼰
//ֵ:
//  >=0  Ԫ,ֵ0ʼ
//  =-1  Ԫز
template<class TYPE>
int FindIndex(TYPE type, TYPE* p, int nArray)
{
  int iResult, i;

  ASSERT(p != NULL);
  iResult = -1;
  for (i = 0; i < nArray; i++)
  {
    if (p[i] == type)
    {
      iResult = i;
      break;
    }
  }

  return iResult;
}

//һƫƾ.
double MaxDistanceOfList(CList<CPoint,CPoint>& listPoint, CPoint& point);

//жϵͶεĹϵ
//:
//  point .
//  listPoint .
//:
//  .
//ֵ:
//  =1,ڶڲ;=0,ڶ;=-1,ڶⲿ.
//˵:
//  ˴Ӧ֤ĵǶ,:βͬ,0.
int PointInList(CPoint& point, CList<CPoint,CPoint>& listPoint);
//жϵͶεĹϵ.
//:
//  point .
//  pt ָ.
//  nArray εԪظ.
//:
//  .
//ֵ:
//  =1,ڶڲ;=0,ڶ;=-1,ڶⲿ.
//˵:
//  ԪӦ2.
int PointInList(CPoint& point, CPoint* pt, int nArray);

//ϲ
//:
//  listPoint .
//:
//  listPoint .
//ֵ:
//  .
//˵:
//  3㹲,ôȥмһ.
//  ˺Ӧñ֤ڵĵ㲻ͬ,˺ж.
void ComboSegment(CList<CPoint,CPoint>& listPoint);

//һ߶ϲһΪֵĵĺ.
//:
//  ߶(ptS,ptE)
//  dY ֵ.
//:
//  dX .(dX,dY)һ߶(ptS,ptE).
//ֵ:
//  .
//˵:
//  úжһǷڶڲ(PointInList)ʱ,ڵô˺֮ǰѾܹ֤
//  Ľһ߶,߶εӳ.
void GetHorizonPoint(CPoint& ptS, CPoint& ptE, double& dY, double& dX);

//
//:
//  ptStartptEnd,ptStartptTemp
//:
//  .
//ֵ:
//  = 1ʱ, = 0, = -1˳ʱ
//˵:
//  ˺ptStartptEndתptStartptTemp˳ʱ뻹ʱ.
//  ʱתǴ180,˵˳ʱ.
//  ˽ǻϵ,ĻϵнҪȡ෴ķ.
//  ˽ֻķ,ֵϵγε2,Ϊ. 
int CrossProduct(CPoint& ptStart, CPoint& ptEnd, CPoint& ptTemp);

//ɸ,ϵһ.
//:
//  ߶(ptS, ptE),з,ԭβ㲻ͬ.
//  dParam ֵ.ϸòֵӦĵ.
//:  .
//ֵ:
//  CPoint.
//˵:
//  ˺һзֵ,߶λͬʱ,ֱӷͷ.
CPoint ParamToPoint(CPoint ptS, CPoint ptE, double dParam);

//Ƿص
BOOL IsOverlapOfTwoPolygon(CList<CPoint,CPoint> &listPolygon1,CList<CPoint,CPoint> &listPolygon2);

//һһ.
//:
//  listPoint .
//:
//  pt ͷָ.
//  nListCount ԪĿ.
//ֵ:
//  =TRUE,ɹ.=FALSE,ʧ.
//˵:  .
BOOL MallocFromList(CList<CPoint,CPoint> &listPoint, CPoint *&pt, int &nListCount);

//ȡе.
//:
//  ptS,ptE .
//:
//  ptMiddle е.
//ֵ:  .
//˵:
//  ô˺ʱ,ĳͬ.
void GetMiddlePoint(CPoint ptS, CPoint ptE, CPoint &ptMiddle);
CPoint GetMiddlePoint(CPoint ptS, CPoint ptE);
//ȡе
CPoint GetMiddlePoint(CList<CPoint,CPoint>& listPoint);

//
//ر˵:
//  Ϊ,>0 Ϊʱ(ĻϿΪ˳ʱ)
//:
//  listPoint 
//ֵ:
//  
double Area(CList<CPoint,CPoint>& listPoint);

//ݸӳ()һ߶.
//:
//  (ptS,ptE) ߶.
//  dLen ߶γ.
//:
//  ptExtend ӳ()߶β.
//ֵ:  .
//˵:
//  ô˺ʱptEptExtendͬһ.
//  ʱ(ptS,ptExtend)ĳΪ.
void ExtendSegment(CPoint &ptS, CPoint &ptE, double dLen, CPoint &ptExtend);
CPoint ExtendSegment(CPoint ptS, CPoint ptE, double dLen);

//߶εĽ.
//:
//  ߶(ptS0,ptE0),(ptS1,ptE1)
//:
//  ptInt .
//ֵ:
//  .
//˵:
//  ÿε˶Ӧͬ.
//  ߶βӦƽ,˺ж.
//  δ߶.Ϊ߶ֱӵĽ.
void IntPoint(CPoint& ptS0, CPoint& ptE0, CPoint& ptS1, CPoint& ptE1, CPoint& ptInt);

//нǵֵֵ.
//:
//  (ptS0,ptE0),(ptS1,ptE1) .
//:
//  dCos нǵֵ.
//  dSin нǵֵ.
//ֵ:
//  =TRUE,ɹ.=FALSE,ʧ.
//˵:
//  ֻе˵˻ͬһʱŻʧ.
//  ˼нϵ¼.
BOOL RotateAngle(CPoint &ptS0, CPoint &ptE0, CPoint &ptS1, CPoint &ptE1, double &dCos, double &dSin);

//ڸĵҵĵ.
//:
//  listPoint .
//  point ĵ.
//:
//  ptNearest .һ.
//  dLen ̵ľ.
//ֵ:
//  TRUE,ҵ.FALSE,ûҵ.ʱʹ.
//˵:
//  ô˺ʱ,ͬ.
BOOL GetNearestPointOnList(CList<CPoint,CPoint> &listPoint, CPoint &point, CPoint &ptNearest, double &dMinLen);

//ԴӵĿβ.
//:
//  alRsc Դ.
//:
//  alDes Ŀ.
//ֵ:  .
//˵:  .
void AddArrayListTail(CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alRsc, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alDes);

//ƽе߶.
//:
//  (ptS,ptE)
//    ߶.һ˵2㲻ͬ.
//  (dStartHeight,dEndHeight)
//    Եƽо.ʹֵ,ʱÿȶ0,ֵԲͬ.
//  bClockwise
//    ת.=TRUE,˳ʱ;=FALSE,ʱ.ע:˴˳ʱ"ϵ",Ļϵ෴.
//  (ptParallelS,ptParallelE)
//    []ƽ֮˵.
//˵:
//  ñʱһҪͬ.
void ParallelSegment(CPoint ptS, CPoint ptE, double dStartHeight, double dEndHeight, BOOL bClockwise, CPoint& ptParallelS, CPoint& ptParallelE);

//ƽ.
//:
//  listPoint
//    .
//  (dHeadHeight,dTailHeight)
//    ͷβ㴦ľ.ʹֵ,ֵԲͬ.
//  bClockwise
//    .ƽкԭߵһ.=TRUE,˳ʱ(ҲĻϵ);=FALSE,ʱ(ҲĻϵҲ).ע:˴˳ʱ"ϵ",Ļϵ෴.
//  listParallel
//    []ƽ֮.
//  dMaxError
//    .жǷΪպϵ.жϳǱպ,ô䰴նε,
//        ڴεʱҪתɵ.
//  bRemoveIntersect
//    =true ȥԽ,=false ȥԽ
//˵:
//  ڵñʱ,ͬ.
void ParalllelCurve(CList<CPoint,CPoint>& listPoint, double dHeadHeight, double dTailHeight, BOOL bClockwise, CList<CPoint,CPoint>& listParallel, double dMaxError = 0.0, BOOL bRemoveIntersect = TRUE);

//ȥԽ.
//:
//  listPoint
//    [][].
//  bClose
//    ʶǷΪպϵ.
//˵:
//  Ǳպϵ,ôն,ѡǸ.ߵ,ôͷ㵽βķв.
void RemoveIntersectPolyline(CList<CPoint,CPoint>& listPoint, BOOL bClose);

//ȡ߽ڲĵ.
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  listPoint
//    .
//  listBorder
//    ߽.ͷβͬҲ,ͬҲ.
//  arrayList
//    [].ж,Ϊĵָܱ˶.
void GetListInBorder(int iDPMM,CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listBorder, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& arrayList);

//ȱĿƵ
//:
//  iDPMM  ȷֱ(һڲλΪ1/iDPMM)
//  (listPoint1,listCtrl1)
//    ʵʵԼӦĿƵ
//  listPoint2
//    ʵʵ
//  listCtrl2
//    []listPoint2ӦĿƵ,еĿlistCtrl1ͬ,ÿλöͨϵıõ
void GetProportionCtrlList(int iDPMM,CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listCtrl1, CList<CPoint,CPoint>& listPoint2, CList<CPoint,CPoint>& listCtrl2);

//timeStarttimeFinishʱ
//:
//  iMillisecondsStart  ʼĺ
//  iMillisecondsFinish  ĺ
//ֵ:
//  ʱ,λ:
double Duration(int iMillisecondsStart,int iMillisecondsFinish);

//Ҹĵе
//:
//  listPoint
//    ,Ҫ֤õǴеĳȡ
//  alCurve
//    
int FindListIndex(CList<CPoint,CPoint>& listPoint, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve);

//㴹߶ϵĲֵ
//:
//  (ptS,ptE)
//    ߶,Ҫ㲻ͬ,ֱӷDBL_MAX
//  point
//    
//ֵ:
//  ֵ,[0,1]߶ڲ
double GetVerticalParam(CPoint ptS, CPoint ptE, CPoint point);

//ݸ߳,
//:
//  iDPMM
//    ȷֱ(һڲλΪ1/iDPMM)
//  listCurve
//    
//  (iDashedLength,iSpaceLength)
//    ߳(ÿһοɼֵĳ),϶(ÿһβɼֵĳ),ʹֵ
//  alCurve
//    [],մͷβ˳,ֶαɼֵĵ
void CustomizeDashedLine(int iDPMM, CList<CPoint,CPoint>& listCurve, int iDashedLength, int iSpaceLength, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve);

//㽥Զ
//:
//  iDPMM                ȷֱ(һڲλΪ1/iDPMM)
//  listCurve            
//  iDashedLength        ߳
//  iSpaceLength         հ׳
//  iDashGradualType     ߳ȵĽ, =0 , =1 Ƚ, =2
//  iDashGradualLength   ߳ȵĽ䳤,:ǰһεĻ߳ȼϸֵںһεĻ߳
//  dDashGradualScale    ߳ȵĽ,:ǰһεĻ߳ȳԸֵںһεĻ߳
//  iSpaceGradualType    հ׳ȵĽ, =0 , =1 Ƚ, =2 
//  iSpaceGradualLength  հ׳ȵĽ䳤,:ǰһεĿհ׳ȼϸֵںһεĿհ׳
//  dSpaceGradualScale   հ׳ȵĽ,:ǰһεĿհ׳ȳԸֵںһεĿհ׳
//  bAdaptiveStretch     =TRUE Ӧ, =FALSE 
//  alCurve              [],մͷβ˳,ֶαɼֵĵ
void CustomizeGradualDashedLine(int iDPMM, CList<CPoint,CPoint>& listCurve, int iDashedLength, int iSpaceLength, 
                                int iDashGradualType, int iDashGradualLength, double dDashGradualScale,
                                int iSpaceGradualType, int iSpaceGradualLength, double dSpaceGradualScale,
                                BOOL bAdaptiveStretch, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve);

//ݸ,뾶,Բ
//:
//  listCurve
//    
//  (iRadius,iSpaceLength,dMaxError)
//    뾶,Բľ(Ͼ),Բεƽ,ĳһֵΪ0Ϊ
//  alPolygon
//    [],մͷβ˳,ֶαԲʵλ
void CustomizeCircleCurve(CList<CPoint,CPoint>& listCurve, int iRadius, int iSpaceLength, double dMaxError, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alPolygon);

//Զ(߻߱պ)
//:
//  listCurve  
//  alCustomCurveElement  ԶԪ
//  bClose  =TRUE պ, =FALSE 
//  ptCustomBasePoint  ׼
//  iCustomCurveHeight  ߶,<=0ʹalCustomCurveElementĸ߶
//  iCustomCurveGap  Ԫصļ,<0,ܳalCustomCurveElementĿ
//  bAdaptiveStretch  =TRUE Զ(ȱıԪصĿȺ͸߶,ʹߵĽǡһԪصĽ), =FALSE (ֵֻԪ)
//:
//  alCurve  ĵ
void CustomizeCurve(CList<CPoint,CPoint>& listCurve, BOOL bClose, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCustomCurveElement, CPoint ptCustomBasePoint, 
                    int iCustomCurveHeight, int iCustomCurveGap, BOOL bAdaptiveStretch, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve);

//С
//
//  listPoint 
//ֵ
// С
//˵
//  תС,ϵͳмֽʱΪַʽ
CRect GetBorderMinRect(CList<CPoint, CPoint> &listPoint);

//ʡɽ޸ı״
//:
//  listPoint1E,listPoint3E
//    []ӦVʡ1Eߺ3E,Ǽ׶ʡ,Ӧ14ߺ35,ɽʱҲͬĵ
//          ʱҪͷǿߵ,Ҫת,ж
//          ͬʱ,Ҫ֤ڱ1->3㳤С3->1㳤,ж
//    []ɹ,ǵͷڱϵ,,֤ͷһڱ
//  listPoint2E
//    ʡ,ʹøͷ߽Գƺʡɽض,Ϊ,ôʹʡмֱȡ
//  listBorder
//    [][]ߵʵʵ,Ҫͷβͬ;ʱѾʡɽ״ӽȥ
//  bClockwise
//    =TRUE ˳ʱ뵹(Ӿϵ˳ʱ),GetNext
//  dMaxError
//    ж13Ƿڱϵֵ,ʡСڸֵͬFALSE
//  ptDartHill
//    []ʡɽļλ,ɺʡɽ뵽,ǲ֪ʡɽ,޸ߵ״(ΪҲǵô˺ɽ)
BOOL CalculateDartHill(int iDPMM, CList<CPoint,CPoint>& listPoint1E, CList<CPoint,CPoint>& listPoint3E, CList<CPoint,CPoint>& listPoint2E, CList<CPoint,CPoint>& listBorder, BOOL bClockwise, double dMaxError, CPoint& ptDartHill);

//㹤ɽ޸ı״
//ر˵:
//  ɽļʡͬ,CalculateDartHill,չ޵Ĺ
//:
//  CalculateDartHillı˵,ע:޲漰
BOOL CalculatePleatHill(int iDPMM, CList<CPoint,CPoint>& listPoint12, CList<CPoint,CPoint>& listPoint34, CList<CPoint,CPoint>& listBorder, double dMaxError);

//ֱ p0p1򣬵p0Ϊ dDistance ĵ
CPoint GetPointOnLine(CPoint p0,CPoint p1,double dDistance);


//20170222 ȡߵĽ
//[] listPoint1,listPoint2  
//[] ptInt
//[] iIntIndex , -1 GetIntPointOfTwoCurve( int iDPMM, CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2, CPoint& ptInt, int iCount)
//                           0, 1,2...listPoint1,listPoint2н㣨ཻӳཻҰlistPoint1ĵ˳ ˳
//[]iCount Ĵ,һ֮Ͳٽе
//ֵ:
//  =TRUE  ɹ˽
//  =FALSE ⽻ʧ,ʹе
//˵
// úͬƽн㣬õͬǽ㲻ͬӵĺ
//  iIntIndexΪ-1ʾԭеĽΪ0 12...ʱʾҪн
BOOL GetIntPointOfTwoCurve( int iDPMM, CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2, CPoint& ptInt, int iIntIndex, int iCount);

//20170222 ȡߵĽ(ཻģ ӳཻ)listPoint1
//[20170911 syf]ʵʵĽ>=2,ôӳ
//[]  listPoint1,listPoint2  
//[] listInt еĽ㣬㰴listPoint1
//ֵ:
//  =TRUE  ɹ˽
//  =FALSE ⽻ʧ,ʹе
//˵
//úз
//1. listPoint1/listPoint2ǷǱպ,н㣬㣬ٰͷβֱӳ(20170911 syfʵʵĽ>=2,ôӳ)
//2. listPoint1/listPoint2һǱպ,һպ; ߽,Ǳպߵӳպ߽
//3. listPoint1/listPoint2Ǳպ,ֱн㷵
BOOL GetIntPointOfTwoCurve_All( int iDPMM, CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2, CList<CPoint,CPoint>& listInt);

//20130717 ȡߵĽ
//[]  listPoint1,listPoint2  
//[] ptInt
//[]iCount Ĵ,һ֮Ͳٽе
//ֵ:
//  =TRUE  ɹ˽
//  =FALSE ⽻ʧ,ʹе
//˵
// ӳཻ
BOOL GetIntPointOfTwoCurve(int iDPMM, CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2, CPoint& ptInt, int iCount);


//20130717 ӳĽ
//[] ptStart,ptEnd  ,з
//[] listPoint  ,⽻,ûӳͷβ
//[] ptInt ,жôֻеһ
//ֵ:
//  =TRUE  ɹ,ʹе
//  =FALSE ʧ,ʹе
BOOL GetExtendInt(int iDPMM, CPoint ptStart, CPoint ptEnd, CList<CPoint,CPoint>& listPoint, CPoint& ptInt);

//20170223ӳĽ
//[] ptStart,ptEnd  ,з
//[] listPoint  ,⽻,ûӳͷβ
//[] listInt 
//ֵ:
//  =TRUE  ɹ,ʹе
//  =FALSE ʧ,ʹе
BOOL GetExtendInt(int iDPMM, CPoint ptStart, CPoint ptEnd, CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listInt);

//20130718 ݸڸϽȡһ  20140427 һֵ
//[]ptPointS ptPointE ȡߵͷβ
//[][]listPoint :ԭʼߣȡ֮
//[] listPointMax 
//˵
// ptPointSΪȡߵͷβ
//ptPointSptPointEȷԭ
//ptPointSptPointEֻһϣϵĽ߷ֳΣһͷβ(С)õҪ
//ptPointSptPointEϣ
//ptPointSptPointEϲߵͬߣصֻptPointSptPointE
//ļlistPointMax
//ptPointS ptPointEڵϣlistPoint;
//һڵϣأlistPointǸڵϵĵ
//ڵϣ ڵ࣬أӵlistPointͷβ
//                       ڵ࣬ͬʱͷβ
void GetCurveSegment(int iDPMM, CPoint ptPointS, CPoint ptPointE, CList<CPoint,CPoint>& listPoint, CList<CPoint,CPoint>& listPointMax);

//20130815 XQ չյ
//:
//  (ptUp,ptDown)
//    չǰֹ
//  (iUpWidth,iDownWidth)
//    չ,ʹֵ,κһȶΪ0
//  bClockWise
//    =TRUE,˳ʱת;=FALSE,ʱת.תΪϵ,Ļϵķ෴
//    ÷ʾ,Ϊ,ôչĽӦóptUp->ptDownbClockWiseһ,Ϊ,Ҫ
//  (ptSpreadUp,ptSpreadDown)
//    []չֹ,ñʱһ(ptUp,ptDown)ʹͬı
//  bAllowNegativeWidth
//    =true Ϊ,=false ,ǿư(ݽṹмչǿչ,ԸñĬֵfalse,20180123 syfӴ˱)
void CalculateSpreadEndPoint(CPoint ptUp, CPoint ptDown, int iUpWidth, int iDownWidth, BOOL bClockWise, CPoint& ptSpreadUp, CPoint& ptSpreadDown, BOOL bAllowNegativeWidth = FALSE);

//жϸǷڵ(Ƿڵĳһ߶)
//:
//  iDPMM      ȷֱ(һڲλΪ1/iDPMM)
//  ptPoint    ĵ
//  listPoint  
//ֵ:
//  =TRUE ڵ
BOOL PointInPolyline(int iDPMM, CPoint ptPoint, CList<CPoint,CPoint>& listPoint);


//20160718 XQ listRefPointlistSortPoint
//[] iDPMM ȷֱ(һڲλΪ1/iDPMM)
//[] listRefPoint ο
//[][] listSortPoint Ҫĵ
//˵:
// listSortPointеĵlistRefPoint˳ŷ,listSortPointĵܲlistRefPoint
void SortIntPoint(int iDPMM, CList<CPoint, CPoint> &listRefPoint, CList<CPoint, CPoint> &listSortPoint);

//TYPE
template<class TYPE>
void Swap(TYPE& p1, TYPE& p2)
{
  TYPE p3;

  p3 = p1;
  p1 = p2;
  p2 = p3;
}

//
template<class TYPE>
void Swap(CList<TYPE,TYPE>& list1, CList<TYPE,TYPE>& list2)
{
  CList<TYPE,TYPE> list3;

  list3.RemoveAll();
  list3.AddTail(&list1);
  list1.RemoveAll();
  list1.AddTail(&list2);
  list2.RemoveAll();
  list2.AddTail(&list3);
}

//ֵ
// [] Value ֵ
// [][] arrayValue 
// [] iCount ݴС
// ˵
//  еÿֵλֵ
template<class TYPE>
void SetSameValue(TYPE Value, CArray<TYPE,TYPE> &arrayValue, int iCount)
{
  int iIndex;

  arrayValue.RemoveAll();
  arrayValue.SetSize(iCount);
  for (iIndex = 0; iIndex < iCount; iIndex++)
  {
    arrayValue[iIndex] = Value;
  }
}
//жÿֵǷ
// [] arryValue 
//ֵ
//  =true ÿֵȣ
//  =false ٴһֵ
//˵
//  ΪʱFalse, ֻһֵTrue
template<class TYPE>
BOOL IsSameValue(CArray<TYPE,TYPE> &arryValue)
{
  BOOL bEqual;
  int iIndex, iCount;
  TYPE Value;

  bEqual = TRUE;
  iCount = arryValue.GetSize();
  if (iCount == 0)
  {
    return FALSE;
  }
  if (iCount == 1)
  {
    return TRUE;
  }

  Value = arryValue[0];
  for (iIndex = 1; (iIndex < iCount) && bEqual; iIndex++)
  {
    if (Value != arryValue[iIndex])
    {
      bEqual = FALSE;
    }
  }

  return bEqual;
}

//жǷȫ
// [] arryValue1 
// [] arryValue2 
//ֵ
//  =true жӦÿֵȣ
//  =false ٴһֵ
template<class TYPE>
BOOL IsSameValue(CArray<TYPE,TYPE> &arryValue1, CArray<TYPE,TYPE> &arryValue2)
{
  BOOL bEqual;
  int iIndex, iCount;

  bEqual = TRUE;
  if (arryValue1.GetSize() != arryValue2.GetSize())
  {
    return FALSE;
  }
  iCount = arryValue1.GetSize();
  if (iCount == 0)
  {
    return TRUE;
  }

  for (iIndex = 0; (iIndex < iCount) && bEqual; iIndex++)
  {
    if (arryValue1[iIndex] != arryValue2[iIndex])
    {
      bEqual = FALSE;
    }
  }

  return bEqual;
}
//ݣԭݿĿ
// [] arryValueSrc ԭ
// [][] arryValueDes Ŀ
template<class TYPE>
void CopyData(CArray<TYPE,TYPE> &arryValueSrc, CArray<TYPE,TYPE> &arryValueDes)
{
  int iIndex, iCount;

  arryValueDes.RemoveAll();
  iCount = arryValueSrc.GetSize();
  for (iIndex = 0; iIndex < iCount; iIndex++)
  {
    arryValueDes.Add(arryValueSrc[iIndex]);
  }
}

//ڸһֵ
// [] arryValue 
//ֵ
//  ֵûֵ0
template<class TYPE>
TYPE FindMaxCount(CArray<TYPE,TYPE> &arryValue)
{
  int iIndex, iCount;
  TYPE MaxValue;

  iCount = arryValue.GetSize();
  if (iCount == 0)
  {
    return 0;
  }
  MaxValue = arryValue[0];
  for (iIndex = 1; iIndex < iCount; iIndex++)
  {
    if (MaxValue < arryValue[iIndex])
    {
      MaxValue = arryValue[iIndex];
    }
  }

  return MaxValue;
}

//λ
//ر˵:
//  úҲ
//:
//  ptPoint        
//  dAngle         XĽǶ(ʾ,ʱ뷽Ϊ),λ:
//  ptButtonHoleS  תǶΪ0ʱĿS
//  ptButtonHoleE  תǶΪ0ʱĿE,SE㹹ĬϵĿ۷(һ˵һˮƽ)
//ֵ:
//  ߶,m_ptPointSʾ۵Ķλλ,m_ptPointEʾ۵ķ
CLineSegment CalculateButtonHolePosition(CPoint ptPoint, double dAngle, CPoint ptButtonHoleS, CPoint ptButtonHoleE);

//λ
//:
//  iDPMM          ֱ
//  listCurve      ʵʵ
//  bClose         =true պ,=false 
//  iLocateType    λ,=0 Ⱦ,=1 Ⱦ
//  bNext          =true ptPointHGetNextķӿ,=false ptPointHGetPrevķӿ
//  iGroupCount    
//  ptPointH       ͷ:Ⱦʱ,ptPointH~ptPointTӿ,Ⱦʱ,ptPointHbNextӿ
//  iDistanceH     һptPointHľ
//  ptPointT       β:ȾʱЧ
//  iDistanceT     һptPointTľ,ȾʱЧ
//  bOnFirst       =true ptPointHiDistanceHĿ,=false 
//  bOnLast        =true ptPointTǰiDistanceTĿ,=false 
//  iSubCount      ÿС׸
//  iSubGap        ÿСļ
//  listGap        ۼļ, > 0 !!!
//                 [i]Ǹii-1ľ,ʸۼȸĿ1 !!!
//                 ǵȾ,Ҹ>1ʱЧ
//  bFixAngle      =true ߳ɹ̶Ƕ
//  dAngle         XĽǶ(ʾ,ʱ뷽Ϊ),λ:
//  ptButtonHoleS  תǶΪ0ʱĿS
//  ptButtonHoleE  תǶΪ0ʱĿE,SE㹹ĬϵĿ۷(һ˵һˮƽ)
//:
//  listLineSegment  ߶,m_ptPointSʾ۵Ķλλ,m_ptPointEʾ۵ķ
void CalculateButtonHolePosition(
  int iDPMM, CList<CPoint,CPoint>& listCurve, BOOL bClose, int iLocateType, BOOL bNext, int iGroupCount,
  CPoint ptPointH, int iDistanceH, CPoint ptPointT, int iDistanceT, BOOL bOnFirst, BOOL bOnLast,
  int iSubCount, int iSubGap, CList<int,int>& listGap, BOOL bFixAngle, double dAngle,
  CPoint ptButtonHoleS, CPoint ptButtonHoleE, CLineSegmentList& listLineSegment);

//λ(ƫ)
//:
//  iDPMM            ֱ
//  listCurve        ʵʵ,
//  bClose           =true պ,=false 
//  iOffsetCount     ۵,ʾһмſ
//  bOffsetLeft      =true λߵ(ʾϵ),=false Ҳ
//  iOffsetDistance  һſߵļ,<0λbOffsetLeftķ
//  iOffsetGapS      ڶſһſ۵ļ,<0λbOffsetLeftķ
//  iOffsetGapE      һſ뵹ڶſ۵ļ,iOffsetGapSΪЧ
//  iLocateType      λ,=0 Ⱦ,=1 Ⱦ
//  bNext            =true ptPointHGetNextķӿ,=false ptPointHGetPrevķӿ
//  iGroupCount      
//  ptPointH         ͷ:Ⱦʱ,ptPointH~ptPointTӿ,Ⱦʱ,ptPointHbNextӿ
//  iDistanceH       һptPointHľ
//  ptPointT         β:ȾʱЧ
//  iDistanceT       һptPointTľ,ȾʱЧ
//  bOnFirst         =true ptPointHiDistanceHĿ,=false 
//  bOnLast          =true ptPointTǰiDistanceTĿ,=false 
//  iSubCount        ÿС׸
//  iSubGap          ÿСļ
//  listGap          ۼļ, > 0 !!!
//                   [i]Ǹii-1ľ,ʸۼȸĿ1 !!!
//                   ǵȾ,Ҹ>1ʱЧ
//  bFixAngle        =true ߳ɹ̶Ƕ
//  dAngle           XĽǶ(ʾ,ʱ뷽Ϊ),λ:
//  ptButtonHoleS    תǶΪ0ʱĿS
//  ptButtonHoleE    תǶΪ0ʱĿE,SE㹹ĬϵĿ۷(һ˵һˮƽ)
//:
//  alLineSegment  ߶,䳤ȵiOffsetCount,m_ptPointSʾ۵Ķλλ,m_ptPointEʾ۵ķ
void CalculateButtonHolePosition(
  int iDPMM, CList<CPoint,CPoint>& listCurve, BOOL bClose, int iOffsetCount, BOOL bOffsetLeft, int iOffsetDistance, int iOffsetGapS, int iOffsetGapE,
  int iLocateType, BOOL bNext, int iGroupCount, CPoint ptPointH, int iDistanceH, CPoint ptPointT, int iDistanceT, BOOL bOnFirst, BOOL bOnLast,
  int iSubCount, int iSubGap, CList<int,int>& listGap, BOOL bFixAngle, double dAngle, CPoint ptButtonHoleS, CPoint ptButtonHoleE, CLineSegmentListArray& alLineSegment);

//ƽϵĶӦ
//:
//  iDPMM         ֱ
//  listCurve     ߵʵʵ
//  bClose        =true պ,=false 
//  ptPoint       listCurveϵһ,δ
//                ڿlistCurveͷ,ôֱӷlistParallelͷ,ͬβ
//  listParallel  listCurveƽ
//:
//  ptParallel  ptPointӦĵ,ݽƽ߼㽻
//ֵ:
//  =true ɹ,=false ʧ
BOOL CalculateParallelPoint(int iDPMM, CList<CPoint,CPoint>& listCurve, BOOL bClose, CPoint ptPoint, CList<CPoint,CPoint>& listParallel, CPoint& ptParallel);

//жǷΪͬһ
//ر˵:
//  (1)µ겻ͬ,ӦñΪͬһ,dxdyͨᳬ1
//  (2)жϱ׼ΪCONST_SAME_POINT_ERROR,ú궨˵
//  (3)ĬʹCONST_SAME_POINT_ERRORж,ҲԴֵ
//:
//  ptPoint1         1
//  ptPoint2         2
//  dSamePointError  жȵֵ,<=ֵĵΪͬһ
//                   >0 ֱʹøֵж
//                   =0 ȫȵĵͬһ,
//                   <0 Զʹ CONST_SAME_POINT_ERROR ж
//ֵ:
//  =true Ϊͬһ,=false 
BOOL PDSIsSamePoint(CPoint ptPoint1, CPoint ptPoint2, double dSamePointError = -1.0);

//жǷ״ͬ
//ر˵:
//  (1)״,ָĻϵʾЧ,ĳȻĳ޹
//  (2)ÿ鶼ת߶CLineSegment,ȻȽ߶Ƿȫغ
//  (3)жԶ/Ԫ/ԪǷΪͬһ
//:
//  alCurve1  1
//  alCurve2  2
//ֵ:
//  =true ״ͬ,=false ״ͬ
BOOL PDSIsSameShape(CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve1, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve2);

//ȫΨһID
//ر˵:
//  https://blog.csdn.net/dpsying/article/details/21415811
//ֵ:
//  ΨһID,ַ=38,{77046E66-C274-42CE-85AD-5DCFA5B4D2A5}
CString PDSCreateGUID(void);

#endif
