#if !defined (READDXFFILE_H)
#define READDXFFILE_H

#include "PDSMath/StdAfx.h"
#include <iostream>
//#include <afxtempl.h>

#include "ReadAutoCAD.h"
#include "ReadASTM.h"
#include "ReadTIIP.h"
//////////////////////////////////////////////////////////////////////////

//ʽϢ
class CStyleInfo : public CObject
{
public:
  CString m_strStyleName;
  CString m_strBaseSizeName;
  CList<CString, CString> m_listAllSize;

  int m_iUnit;  //0 mm;=1 Inch

  CString m_strAuthor;
  CString m_strVersion;  //20180127 汾

  CStyleInfo(void);
  CStyleInfo(CStyleInfo& a);
  ~CStyleInfo(void);

  void operator=(CStyleInfo& a);
  void Initial(void);
};

class CReadDxfData : public CObject
{
public:
  int m_iDPMM;
  //ʽϢʽϢ
  CStyleInfo m_StyleInfo;

  BOOL m_bPattern;  //=true ֽ=falseṹ

  //ṹϢ
  CCurveNotchInforList m_listCurveOfFile;  //ļеϢ
  CTextDataList m_listTextOfFile;  //ļַϢ
  CLayerInforList m_listLayer;

  //ֽϢ
  CPatternBlockList m_listPattern;  //ֽ
  // ñֻжrulļ
  int m_iGradeCount;  //
  int m_iSizeCount;  //͸
  //m_iSizeCount, m_iGradeCountֻm_RulData
  CPointData **m_pRulData;  //m_RulData[iSizeIndex][iGradeIndex]

public:
  CReadDxfData(void);
  CReadDxfData(CReadDxfData& a);
  ~CReadDxfData(void);

  void operator=(CReadDxfData& a);
  void Initial(void);

  CRect GetRect();

  //ʵʵ
  void CalcuateActualPoint(int iDPMM);

  //20200219 XQ ֽʵʵ
  //[][] pPatternBlock ֽ
  void CalcuateActualPoint(int iDPMM, CPatternBlock *pPatternBlock);

  //
  //
  //dScale ŴС
  //˵
  // Ҫƫƣ
  void SetScale(double dScale);

  //ɫ
  //
  //  strLayer ɫڲ
  //ֵ
  //ɫ
  COLORREF GetColor(CString strLayer);

  //ɫ(Auto CAD Ӧɫ)
  //
  //  strColor ɫ
  COLORREF FinColorTable(CString strColor);

  //õ
  //:
  //  iFileType = 0 ASTM/AAMA;=1 TIIP;=2 AutoCAD
  //  strCurveViewType ļ
  //ֵ:
  //  ϵͳPS_SOLID...
  int GetCurveType(int iFileType, CString strCurveViewType);


private:
  void DeleteElta();

  void CopyData(CReadDxfData &a);

  //TIIPļת
  //
  //  iValue ļеֵ
  //ֵ
  //  ϵͳ
  int CurveType_TIIP(int iValue);

};

//ļ
//:
//  strFilePathļ·
//  bPattern =trueֽfalse ṹ
//  bReadSolid = trueʶߣ=false  20210902 XQ
//:
//  AutoCADDxfData 
//ֵ:
// =true ȷ=false
BOOL ReadAutoCADFile(CString strFilePath, BOOL bPattern, BOOL bReadSolid, CReadDxfData &AutoCADDxfData);


//ת
//[] EntitiesInfor 
//[] bPattern =trueֽfalse ṹ
//[] AutoCADDxfData 
void GetAutoCADDxfData(CAutoCADFileInfo FileInfo,  BOOL bPattern, CReadDxfData &AutoCADDxfData);

//õ
//[] BlockInfor Ϣ
//[] listBlockInfor пϢ
//[][] listCurveOfFile Ϣ
//[][] listTextOfFile ıϢ
//[] dOffsetX/dOffsetYλ
//[] dSin,  dCos תǶ
//[] dScaleX/dScaleY ŴС  20220408 XQ
void GetAutoCADDxfData(CAuBlockInfor BlockInfor, CAuBlockInfoList &listBlockInfor, CCurveNotchInforList &listCurveOfFile, CTextDataList &listTextOfFile, double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

//ת
//
//  strFilePath ļ·
//  bPattern =true ֽ false ṹߣ ṹ߲örul
//  bOnlyReadBaseSize =true 룬 ֽЧ
//
//ASTMDxfData 
//ֵ:
//  = 0 ɹ
//  = 1 ļ򲻿
//  = 2 AutoCADļ
//  = 3 TIIPļ
int ReadASTMFile(CString strFilePath, BOOL bPattern, BOOL bOnlyReadBaseSize, CReadDxfData &ASTMDxfData);

//ת
//
//  FileInfo ļϢ
//  bPattern =true ֽ false ṹߣ ṹ߲örul
//  bOnlyReadBaseSize =true 룬 ֽЧ
//
//ASTMDxfData 
void GetASTMData(CASTMFileInfor FileInfo, BOOL bPattern, BOOL bOnlyReadBaseSize, CReadDxfData &ASTMDxfData);

//CAMBlockInforתCPatternBlock
BOOL TrantsAMPatternBlock(CString strAuthor, CAMBlockInfor BlockInfor, CPatternBlock &PatternBlock);


//ת
//
//  strFilePath ļ·
//  bPattern =true ֽ false ṹߣ ṹ߲örul
//  bOnlyReadBaseSize =true 룬 ֽЧ
//
//AutoCADDxfData 
//ֵ:
//  = 0 ɹ
//  = 1 ļ򲻿
//  = 2 AutoCADļ
//  = 3 ASTM/AAMAļ
int ReadTIIPFile(CString strFilePath,  BOOL bPattern, BOOL bOnlyReadBaseSize, CReadDxfData &AutoCADDxfData);

//ת
//
//  FileInfo ļϢ
//  bPattern =true ֽ false ṹߣ ṹ߲örul
//  bOnlyReadBaseSize =true 룬 ֽЧ
//
//AutoCADDxfData 
void GetTIIPData(CTIIPFileInfor FileInfo, BOOL bPattern, BOOL bOnlyReadBaseSize, CReadDxfData &AutoCADDxfData);

//CTPBlockInforתCPatternBlock
BOOL TrantsTPPatternBlock(CTPBlockInfor BlockInfor, CPatternBlock &PatternBlock);

#endif
